(sys-load "lib/matrices.scm")

;; Based on http://ocw.mit.edu/courses/electrical-engineering-and-computer-science/6-837-computer-graphics-fall-2012/lecture-notes/MIT6_837F12_Lec01.pdf

(define bernsteins (matrix #(1 -3  3 -1)
                           #(0  3 -6  3)
                           #(0  0  3 -3)
                           #(0  0  0  1) ))

(define bernsteins-i (matrix #(1  1   1   1)
                             #(0  1/3 2/3 1)
                             #(0  0   1/3 1)
                             #(0  0   0   1) ))

(define (B t) (let* ((t3   (* t t))
                     (t4   (* t t3))
                     (T    (vector 1 t t3 t4)))
 (vector-map (lambda (b) (vector-dot b T)) bernsteins)))

(sys-load "VSI-core/repl.scm") (repl-transcript
(define C (matrix-from-columns #(1/2 4/4) #(0 2/4) #(1 3/4) #(5/10 0)))
(B 0) (B 1/2) (B 1)
(define (P t) (let ((Bt (B t)))
                (vector (vector-dot (matrix-row C 0) Bt)
                        (vector-dot (matrix-row C 1) Bt)) ))
(P 0) (P 1/4) (P 1/2) (P 1)
)

(sys-load "GIO/gio.scm")

(define bw-class (class  (extension window-class)
 (slots gc gcc)
 (method initialize () (super sys-display 50 50 500 500 0)
                       (this (set! 'gc (make-object graphics-context-class this)))
                       (this (set! 'gcc (make-object graphics-context-class this)))
                       ((this gcc) (set-color 'foreground black))
                       ((this gcc) (set-color 'background white))
                       ((this gc) (set-color 'background white))
                       ((this gc) (set-color 'foreground (color '(rgb-bytes 192 160 0))))
                       (this (activate-events expose-event-class)))
 (method expose-event (event)
  (let ((dot-size 20)
        (marg     50)
        (step 1/20))
  (let loop ((t 0))
   (when (<= t 1) (let* ((p (P t))
                         (x (+ marg (round (* 400 (vector-ref p 0)))))
                         (y (+ marg (- 400 (round (* 400 (vector-ref p 1)))))))
    ;(X-log-debug (format "t x y: ~A (~A, ~A)" t x y))
    ((this gc) (polifill-arc x y dot-size dot-size (* 360 64) (* 360 64)))
    (loop (+ t step)) )))

 (vector-for-each
  (lambda (p) (let* ((x (+ marg (round (* 400 (vector-ref p 0)))))
                     (y (+ marg (- 400 (round (* 400 (vector-ref p 1)))))))
                ((this gcc) (polifill-arc x y dot-size dot-size (* 360 64) (* 360 64))) ))
  (matrix-transpose C))
 ))
))

(sys-load "VOS/xi.class.scm")
(repl-transcript
 (define w (make-object bw-class))
 (w (show))
 (define x (make-object xi-class))
 (x (start))
)
