
(define (bit-reverse/reference byte-string)
 (let* ((length (byte-string-length byte-string))
        (bits   (- (* 8 length) 1))
        (source (byte-string-copy byte-string))
        (result (byte-string-clear! (make-byte-string length)))
        (mask   (number->byte-string 1 length)))
  (let loop ((n 0))
   (when (bit-and? source mask) (set! result (bit-or result mask)))
   (when (not (= n bits))
    (bit-shift-right! source 1)
    (bit-shift-left!  result 1)
    (loop (+ n 1))))
  result))

(sys-load "VSI-core/repl.scm")

(repl-transcript
(define a #"128")
(bit-reverse/reference a)
)
(newline)
;(REPL)
  
(define (list-bit-order-values)
  (display "// Bit Reversed Byte (char) Lookup Table")
  (newline)
 (let loop ((n 255))
  (cond
   ((< n 0) '())
   (else (cons
          (byte-string->number
           (bit-reverse!
            (byte->byte-string n)))
          (loop (- n 1))) )) ))

(define (print-bit-order-table table)
 (let ((last (first table))
       (n-line 16) (n 0))
  (display "unsigned const char bit_reverse_lookup_table[256] = {")
  (newline)
  (for-each (lambda (element)
              (display element)
              (display ", ")
              (set! n (+ n 1))
              (when (= n-line n)
                (set! n 0)
                (newline)))
            (reverse! (cdr table)))
  (display last)
  (display "};")
  (newline)))

(print-bit-order-table (list-bit-order-values))

(define (list-bit-order-values-2)
 (let loop ((n 65535))
  (cond
   ((< n 0) '())
   (else (cons
          (byte-string->number
           (bit-reverse!
            (number->byte-string-2 n)))
          (loop (- n 1))) )) ))

(define (print-bit-order-table-2 table)
  (newline)
  (newline)
  (display "// Bit Reversed Two Bytes (short) Lookup Table")
  (newline)
 (let ((last (first table))
       (n-line 12) (n 0))
  (display "unsigned const short bit_reverse_lookup_table_2[65536] = {")
  (newline)
  (for-each (lambda (element)
              (display element)
              (display ", ")
              (set! n (+ n 1))
              (when (= n-line n)
                (set! n 0)
                (newline)))
            (reverse! (cdr table)))
  (display last)
  (display "};")
  (newline)
  ))

; Too much output for this example. ;-)
;(print-bit-order-table-2 (list-bit-order-values-2))


(force-output) ; saw a missing table tail w/o this
;(REPL)
