(define R (namespace-load (%search-load-path "VSI-core/repl.scm")))
(sys-load "VOS/vos.scm")
(sys-load "GIO/gio.scm")
(sys-load "VOS/xi.class.scm")
(sys-load "lib/polar.scm")

 (define (half-steps color-steps)
  (flatten! (map (lambda (s1 s2) (list s1 (vector-middle s1 s2)))
                 color-steps
                 (append (cdr color-steps) (list (first color-steps))))))

(define color-pad-class (class                              (extension window-class)
 (slots gc size)
 (slots hue value saturation)
 (slots rgb)

 (method initialize (color parent x y)
  (this (set! 'rgb  color))
  (this (set! 'size 92))
  (super parent x y (this size) (this size) 1)
  (this (set! 'gc (make-object graphics-context-class this)))
  (this (set! 'value      1))
  (this (set! 'saturation 1))
  (X-log-debug color "(" x "," y")")
  ((this gc) (set-color 'foreground color))
  (this (activate-events expose-event-class))
 )

 ;(define (apply-saturation-value this color) (color-value (color-saturation color (this saturation)) (this value)))
 (define (apply-saturation-value this color) (color-saturation (color-value color (this value)) (this saturation)))
 (method draw ()
   ;((this gc) (set-color 'foreground (apply-saturation-value this (this rgb))))
   ;(X-log-debug (this rgb) "("(this x)","(this y)")")
   ((this gc) (polifill-arc 0 0 (this size) (this size) 0 (* 360 64)))
 )

 (method expose-event (event)
  (this (draw))
 )

)) ; closes color-pad-class

(define REPL-HERE (from-namespace R 'REPL-HERE))

(define color-wheel-class (class (extension window-class)
 (slots steps label)
 (define default-steps (half-steps (list red yellow green cyan blue magenta )))
 (define (screen-x cv) (inexact->exact (round (vector-ref cv 0))))
 (define (screen-y cv) (inexact->exact (round (vector-ref cv 1))))

 (method initialize (parent name . colors) (super parent 50 50 600 600 0)

  (this (set! 'label (make-object label-class name this 10 10 500 0)))
  ((this label) (show))

  (cond ((null? colors) (this (set! 'steps default-steps)))
        (else           (this (set! 'steps (car colors)))))

  (let* ((pv     (cartesian->polar #(0 -200)))
         (origin #(250 250))
         (l      (length (this steps)))
         (2pi    (* 2 pi))
         (step   (- (/ 2pi l)))
         (i      0))
  (for-each (lambda (c) (let ((cv (vector-plus origin (polar->cartesian (polar-rotate pv (* i step))) )))
              ((make-object color-pad-class c this (screen-x cv) (screen-y cv)) (show))
              (set! i (+ i 1)) ))
            (this steps))
 ))
)) ; closes color-wheel-class


(define (pad color) ((make-object color-pad-class color sys-display 50 50) (show)))
(define (p color) (let ((w (make-object color-pad-class color ipol-wheel 50 50))) (w (show)) w))

(when #t ((from-namespace R 'repl-transcript)

(define  ipol-wheel (make-object color-wheel-class sys-display "RyGcBm Interpolations"
   (map (lambda (C) (color-value (color-saturation C 1/2) 6/8))
        (half-steps color:rainbow))))
(define compl-wheel (make-object color-wheel-class sys-display "Complementary Colors with Interpolations"
   (map (lambda (C) (color-value (color-saturation C 1/2) 6/8))
    (half-steps (list red orange-color yellow lime-color green blue cyan magenta)))))
 (ipol-wheel (show))
(compl-wheel (show))


(define x (make-object xi-class))
(x (start))

))
