(sys-load "VSI-core/repl.scm")
(sys-load "GIO/gio.scm")

;(define fonts (sys-display (list-fonts "*")))
;(define exts  (sys-display (X-extensions)))


(define myw-class (class (extension window-class) (slots font gc menu sdraw) (slots following)
 (method initialize () (super sys-display 50 50 300 400 0)
                       (this (set-following #t))
                       (this (set! 'sdraw 0))
                       (this (set! 'font (make-object font-class sys-display
                                           ;"-misc-fixed-medium-r-normal--20-140-100-100-c-100-iso8859-1")))
                                           "-bitstream-bitstream charter-bold-r-normal--0-0-0-0-p-0-iso8859-1")))
                       (this (set! 'gc (make-object graphics-context-class this)))
                       (let ((gc (this gc)))
                        (gc (set-font (this font)))
                        (gc (set-color 'foreground black))
                        (gc (set-color 'background vsiblue) ))
                       (let ((menu (make-object menu-class this 10 10 200 200)))
                         (this (set! 'menu menu))
                         (make-object menu-item-class menu "Dagobert Duck I"  (lambda () (X-log-debug "DD sdraw " (this sdraw))))
                         (make-object menu-item-class menu "Follower"         (lambda () (this (switch-following)) ))
                         (make-object menu-item-class menu "quit"             (lambda () (xit)))
                         (make-object menu-item-class menu "----------------" (lambda () 'noop)) ; How about some seperator item???
                         ;(make-object menu-item-class menu " "                (lambda () 'noop))
                         (make-object menu-item-class menu "GIO font"         (lambda () ((this gc) (set-font gio-font))))
                         (make-object font-menu-item-class (this font) menu "myw font" (lambda () ((this gc) (set-font (this font)))))
                         (menu (adjust-dimensions))
                       )
                       (let ((p ((this display) pointer-device))
                             (k ((this display) keyboard)))
                         (p (add-button-listener this))
                         (k (add-key-listener this))
                       )
                       (this (activate-events expose-event-class))
 )
 (method set-following (do-follow) (this (switch-following do-follow)))
 (method switch-following ( . args)
  (this (set! 'following (cond ((= 1 (length args)) (not (not (car args))))
                               ((null? args)        (not (this following)))
                               (else                (X-log-debug "myw class switch-following argument issue: " args))) ))
  (let ((p ((this display) pointer-device)))
    (if (this following)
      (p (add-motion-listener    this))
      (p (remove-motion-listener this)) ))
 )


 (method show () ((this menu) (show)) (super))
 (method draw () #t)
 (define wrapper-event-class (class (extension display-object-class) (slots event-x event-y)
                              (method destroy () #t) ; goes to viper object class please?
                              (method initialize (expose-event)
                               (this (set! 'event-x (expose-event x)))
                               (this (set! 'event-y (expose-event y))))))
 (method expose-event (event)
  (cond
  ((= 0 (event count)) (let ((ev (make-object wrapper-event-class event)))
                         (this (clear))
                         (draw-logo this ev)
                         (ev (destroy))))
  (else                (this (set! 'sdraw (+ 1 (this sdraw)))))
 ))

 (define (draw-event-arc this event)
   (let* ((width 100) (height 100)
          (x (- (event event-x) (quotient width  2)))
          (y (- (event event-y) (quotient height 2))))
    ((this gc) (polifill-arc x y width height (* 60 64) (* 180 64))) ))
 (define (draw-logo this event)
   ;; Actually such a complex drawing class private routine is non sense:
   ;;  even the most simple cases should be a drawable or window and keep
   ;;  their state. Only relying on the events to create the illusion of
   ;;  a mutable position of the logo doesn't work out well.
    (draw-event-arc this event)
    ((this gc) (set-color 'foreground white))
    (this (set! 'last-x (event event-x)))
    (this (set! 'last-y (event event-y)))
    ((this gc) (image-text-8 (event event-x) (event event-y) "VSI/GIO"))
    ((this gc) (set-color 'foreground black))
)
 (method motion-event (event)
  ;(this (clear))
  (draw-logo this event)
  ;(wait 20)
  ;(X-log-debug (event (describe)))
  (begin #t) ; empty overridden method leads to some strange memoization error message from let*
 )
  ;(super event))
 (slots last-x last-y)
 (method button-event (event)
  (cond
  ((and (eq? (event type) 'down))
  (case (event button)
  ((1) (this (clear)) (draw-logo this event) )
  ((4)
    (this (set! 'last-y (+ (this last-y) scroll-step)))
    (event (set! 'event-x (this last-x)))
    (event (set! 'event-y (this last-y)))
    (this (clear))
    (draw-logo this event))
  ((5)
    (this (set! 'last-y (- (this last-y) scroll-step)))
    (event (set! 'event-x (this last-x)))
    (event (set! 'event-y (this last-y)))
    (this (clear))
    (draw-logo this event))
  ((6)
    (this (set! 'last-x (+ (this last-x) scroll-step)))
    (event (set! 'event-x (this last-x)))
    (event (set! 'event-y (this last-y)))
    (this (clear))
    (draw-logo this event))
  ((7)
    (this (set! 'last-x (- (this last-x) scroll-step)))
    (event (set! 'event-x (this last-x)))
    (event (set! 'event-y (this last-y)))
    (this (clear))
    (draw-logo this event))
  (else                     (super event))
  )))
  ;(super event)
 )
(define scroll-step 8)
 (method key-event (event) (X-log-debug (event (describe))) ;(super event) 
   (this (clear))
   ((this gc) (set-color 'foreground white))
   ((this gc) (image-text-8 20 20 "VSI/GIO"))
   ((this gc) (set-color 'foreground black))
   (this (draw))
 )
))

(repl-clear)
(repl-transcript
(define w (make-object myw-class))
(w (show))
;; There's some race condition here where events might
;; already be queued but we still start from sys-control roll
;; which only invokes the channel handler (which knows about
;; the queue) when a new event arrives. Thus currently one
;; event is perhaps processed out of order right after the
;; call /sys-control roll/.
(sys-load "VOS/xi.class.scm")
(define x (make-object xi-class))
(x (start))
)
;(REPL)
