(sys-load "VSI-core/repl.scm")
(sys-load "VOS/vos.scm")
(sys-load "GIO/gio.scm")
(sys-load "VOS/xi.class.scm")
(sys-load "lib/matrices.scm")

(define color-matrix-view-class (class       (extension window-class)
 (slots gc pixmap bg)

;(define band-height 600)
(define band-height 10)
(define number-of-hues 1525)
;(define number-of-hues 768)
(define hues
 (let ((start 6)
       (end   0)
       (step (- (/ 6 number-of-hues))))
  (log-debug "step " step)
  (let loop ((hue start) (hues '()))
   (cond ((= hue end) hues)
         (else        (loop (+ hue step)
                            (cons (color (list 'hsv hue 1 1)) hues) ))) )))

(define (hue-matrix height)
 (let ((hue-cols (list->vector (map (lambda (H) (make-vector height H)) hues))))
  (matrix-transpose hue-cols)))

(define the-hue-matrix (hue-matrix band-height))

(define (color-matrix->pixels M converter) (apply byte-string-adjoin (map converter (matrix->list M))))

(method initialize (parent) (super parent 50 50 number-of-hues band-height 0)
 (this (set! 'pixmap (make-object pixmap-class           this   (this width) (this height))))
 ((this pixmap) (set-pixels-from-color-matrix the-hue-matrix (this (get-color->pixel:converter))))
 ;(this (set-background-pixmap (this pixmap)))
 (this (set! 'gc     (make-object graphics-context-class this))) ;(this pixmap))))
 ;((this pixmap) (set-pixels (color-matrix->pixels the-hue-matrix (this (get-color->pixel:converter)))))
 ;((this gc)     (put-image this (this width) (this height) 0 0 (this pixmap)))
 (when #f ; shm pixmap testing paragraph
          ; Sometimes an access error results for the regular??? pixmap / after the test when this
          ; test is enabled.
   (X-log-debug "SHM Pixmap testing paragraph " (((this pixmap) x-shared-mem) (describe)))
   (X-log-debug (global-object-delta))
   (let loop ((idx (* 129 1))) (when (> idx 0)
    ((make-object pixmap-class this (this width) (this height))  (destroy))
    (loop (- idx 1)) ))
   (X-log-debug (global-object-delta))
 )
 (when #f (let ((gcl '())) ; this leaks two cells per gc <- that's little: every object in the riddle needs some
   (X-log-debug "GC testing paragraph " (global-object-delta))
   (let loop ((idx (* 40 1k))) (when (> idx 0)
    (set! gcl (cons (make-object graphics-context-class this) gcl))
    (loop (- idx 1)) ))
   (X-log-debug (global-object-delta))
   (for-each (lambda (gc) (gc (destroy))) gcl)
   (set! gcl #f)
   (X-log-debug (global-object-delta))
 ))
 (this          (activate-events expose-event-class))
)

(method expose-event (event) #t
 ;(X-log-debug "color matrix view class: expose event")
 ((this gc)     (put-image this (this width) (this height) 0 0 (this pixmap))) ; XXX there's some bad value error for unattended resizes
                                                                               ; ??? Maybe we can make this the background pixmap w/o bad match but it's "fast" right now.
)                                                                              ; -> restrict by window manager property ipc <- TODO
))                                                                             ; -> try this example with an inner window <- OK


(when #t (repl-transcript

(define v (make-object window-class sys-display 50 50 (+ 100 1525) (+ 100 100) 0))
(define w (make-object color-matrix-view-class v))
(w (show))
(v (show))
;(define p (make-object pixmap-class r (r width) (r height)))
;(sys-control (roll))
(define x (make-object xi-class))
(x (start))

))

(REPL)
