(sys-load "VSI-core/posix.constants.scm")

;;
;; Posix File Access Flags
(define (fs-access:access-flag flag)
 (case flag
  ((read)    S_IRUSR)
  ((write)   S_IWUSR)  
  ((execute) S_IXUSR)
  (else
   (error "fs-access expects read/write/execute as access flag:" flag))))

(define (fs-access:shift audience flag)
 (case audience
  ((user)   flag)
  ((group)  (bit-shift-right flag 3))
  ((others) (bit-shift-right flag 6))
  (else
   (error "fs-access expects user/group/others as audience:" flag))))

(define (fs-access-list->mode-bits access-list)
 (apply bit-or
  (map (lambda (access)
        (apply bit-or
         (map (lambda (flag)
               (fs-access:shift (car access) flag))
              (map fs-access:access-flag
                   (cdr access) )) ))
       access-list)))

(define (fs-access file positive-access-list)
 (chmod file (fs-access-list->mode-bits positive-access-list)))
;;
;; where positive-access-list is a list of entries
;; (audience flag ...)
;;
;; where audience is one of: user group others
;;      and flags is one of: read write execute
;;

;;
;; Example usage of fs-access:
;;
;; (fs-access "tst" '((user read write) (group read) (others read)))
;; (fs-access "tst" '((user execute read)))
;;

(sys-load "VSI-core/repl.scm")
(REPL)
