(sys-load "VSI-core/repl.scm")
(sys-load "VOS/vos.scm")
(sys-load "GIO/gio.scm")
(sys-load "VOS/xi.class.scm")
;(sys-load "Examples/polar.scm")


(define rainbow-class (class                              (extension window-class)

 (define (half-steps color-steps)
  (flatten! (map (lambda (s1 s2) (list s1 (vector-middle s1 s2)))
                 color-steps
                 (append (cdr color-steps) (list (first color-steps))))))

 (define (polarize1 c)
  (let* ((radius 127)
         (cunit  (once (vector-magnitude #(255 255 255))))
         (length (vector-magnitude c))
         (scale2 (vector-scale radius (vector-scale (/ 1 cunit) c) )))
   (list->vector (map inexact->exact (vector->list scale2)))))

 ; 3d maximum length for 45o 45o (vector-magnitude #(255 255 255))
 ; 2d maximum length             (vector-magnitude #(255 255 0))
 ; 1d maximum length             (vector-magnitude #(255 0 0))
 ;; (define (polarize2 c)
 ;;  (let* ((origin #(128 128 128))
 ;;         (cv (vector-minus origin c))
 ;;         (pv (cartesian->polar c))
 ;;         (

 ;(define default-steps (map polarize1 (list red yellow green cyan blue magenta)))
 (define default-steps (map identity (list red yellow green cyan blue magenta )))
 ;(define default-steps (map (lambda (c) (color-saturation c 1/2)) (list red yellow green cyan blue magenta )))

 (slots gc steps value saturation)
 (method initialize (parent) (super parent 50 50 800 300 0)
  (this (set! 'gc (make-object graphics-context-class this)))
  (this (set! 'steps default-steps))
  (this (set! 'value      1))
  (this (set! 'saturation 1))
  (this (set! 'buf        #f))
  (this (activate-events expose-event-class))
  ((sys-display keyboard) (add-key-listener this))
 )

 ;(define (apply-saturation-value this color) (color-value (color-saturation color (this saturation)) (this value)))
 (define (apply-saturation-value this color) (color-value (color-saturation color (this saturation)) (this value)))
 (slots buf)
 (method draw ()
  (let ((con ((this display) connection)))
  (cond
  ((this buf) (X-play con (this buf)))
  (else
  ;(X-rec-start! con)
  (let* ((size 100)
         (off (ceiling (/ (- (this width) size) (+ 1 (length (this steps)))) ))
         (dis 0))
   ;(X-log-debug "steps " (length (this steps)) " off " off)
   (for-each (lambda (c) ;(X-log-debug "color " c)
                         ((this gc) (set-color 'foreground c))
                         ((this gc) (polifill-arc dis 100 size size 0 (* 360 64)))
                         (set! dis (+ dis off)) )
             (map (lambda (c) (apply-saturation-value this c)) (this steps)))
   ((this gc) (set-color 'foreground (apply-saturation-value this (first (this steps)))))
   ((this gc) (polifill-arc dis 100 size size 0 (* 360 64)))
  )
  ;(slot-set! (this) 'buf (X-rec-end! con))
  ;(this (draw))
)) ))

 (method expose-event (event)
  (this (draw))
 )

 (define (every-second lst)
  (cond
  ((null? lst)        '())
  ((null? (cdr lst))  (list (first lst)))
  ((null? (cddr lst)) (list (second lst)))
  (else               (cons (first lst) (every-second (cddr lst)) )) ))

 (define vs-step 1/24)

 (method key-event (event)
  (this (set! 'buf #f))
  (let ((el (list (event type) (event value))))
      ;(X-log-debug el)
  (cond
  ((equal? el '(down Escape)) (xit))
  ((equal? el '(down #\space)) (let* ((pixels     (map (lambda (color) (this (color->pixel color)))
                                                       (this steps)))
                                      (duplicates (list-duplicates pixels)))
                                 (X-log-debug "duplicates " duplicates
                                            " value " (this value)
                                            " saturation " (this saturation) )))

  ((equal? el '(down Down))  (this (set! 'value      (max 0 (- (this value)      vs-step))))  (this (draw)))
  ((equal? el '(down Up))    (this (set! 'value      (min 1 (+ (this value)      vs-step))))  (this (draw)))
  ((equal? el '(down Left))  (this (set! 'saturation (max 0 (- (this saturation) vs-step))))  (this (draw)))
  ((equal? el '(down Right)) (this (set! 'saturation (min 1 (+ (this saturation) vs-step))))  (this (draw)))

  ((equal? el '(down Return))
     ;; (- (* 255 6) 5) => 1525 should be the maximum of representable hues.
     (this (set! 'steps (half-steps (this steps))))
     (this (clear))
     (this (draw)))
  ((equal? el '(down BackSpace)) (let ((lh (quotient (length (this steps)) 2)))
   (cond 
    ;((<= lh 3) (this (set! 'steps (list red green blu))))
    ;((<= lh 3) (this (set! 'steps (list yellow cyan magenta ))))
    ((<= lh 3) (this (set! 'steps (list orange-color turquoise-color violet-color))))
    ((<= lh 6) (this (set! 'steps default-steps)))
    (else      (this (set! 'steps (every-second (this steps)))) )))
     (this (clear))
     (this (draw)))
 )))

)) ; closes rainbow-class



(when #t (repl-transcript

(define r (make-object rainbow-class sys-display))
(r (show))
(define p (make-object pixmap-class r (r width) (r height)))
;(sys-control (roll))
(define x (make-object xi-class))
(x (start))

))
