
   ;;   ;;   ;;     Graphical        Viper System Interface
 ;;     ;; ;;  ;;   Input                    SCA/X
 ;;  ;; ;; ;;  ;;   Output            Viper Object System
   ;;   ;;   ;;                  

;; DISPLAY These should be inner classes of the display-class


(define x-extension-class (class               (extension display-object-class) ; virtual
  (slots name major-opcode first-event first-error is-present)

(method initialize (display name) (super display)
 (let* ((fbw (fixed-call xext 'X-query-extension (display connection) name)))
  (this (set! 'name name))
  (this (set! 'is-present   (byte-string-true?   (fixed-call xext 'xrr-query-extension:present      fbw))))
  (this (set! 'major-opcode (byte-string->number (fixed-call xext 'xrr-query-extension:major-opcode fbw))))
  (this (set! 'first-event  (byte-string->number (fixed-call xext 'xrr-query-extension:first-event  fbw))))
  (this (set! 'first-error  (byte-string->number (fixed-call xext 'xrr-query-extension:first-error  fbw))))
))

(define xext (namespace (namespace-import sca/x-common)
(define X-rp-query-extension
 (byte-structure-description
  (opcode      1)
  (padding     1)
  (request-length 2)
  (length-of-name 2)
  (padding        2)))
(define-bs-accessors 'xrp-query-extension X-rp-query-extension)
(define X-query-extension:template
 (let ((template (make-byte-string (bs-length X-rp-query-extension))))
  (byte-string-clear! template)
  (xrp-query-extension:set-opcode! template (byte->byte-string 98))
  template))
(define X-rr-query-extension
 (byte-structure-description
  (reply      1)
  (padding    1)
  (sequence-number 2)
  (reply-length    4)
  (present         1)
  (major-opcode    1)
  (first-event     1)
  (first-error     1)
  (padding        20)))
(define-bs-accessors 'xrr-query-extension X-rr-query-extension)
(define (X-query-extension connection name)
 (let* ((rb X-query-extension:template)
        (pl (brass-length name))  ;; TODO verify C0
        (bp (brass->string-8 name))
        (rl (+ (byte-string-length rb) (byte-string-length bp)))
        (pad (byte-string-clear! (make-byte-string (- 4 (modulo rl 4)))))
        (pad (if (= 4 (byte-string-length pad)) (make-byte-string 0) pad))) ;; padding patch
  (xrp-query-extension:set-length-of-name! rb (number->byte-string-2 pl))
  (xrp-query-extension:set-request-length! rb (number->byte-string-2 
                                           (/ (+ rl (byte-string-length pad))
                                              4)))
  (X-request connection (byte-string-adjoin rb bp pad) (lambda (con fbw) fbw))
))
)) ; closes xext namespace
)) ; closes X Extension Class

