
   ;;   ;;   ;;     Graphical        Viper System Interface
 ;;     ;; ;;  ;;   Input                    SCA/X
 ;;  ;; ;; ;;  ;;   Output            Viper Object System
   ;;   ;;   ;;                  

;; DISPLAY These should be inner classes of the display-class
;; X Extension


(define xext-big-requests-class (class (extension x-extension-class)

(method initialize (display) (super display "BIG-REQUESTS")
 (let* ((max (fixed-call xbr 'X-big-req-enable ((this display) connection) (this major-opcode))))
   (X-log-info "VSI GIO SCA/X big requests: maximum request size " max)
))

(define xbr (namespace (namespace-import sca/x-common)
(define Xbr-rp-use-extension
 (byte-structure-description
  (opcode         1)
  (minor-opcode   1)
  (request-length 2) ))
(define-bs-accessors 'xbrrp-use-extension Xbr-rp-use-extension)
(define Xbr-rr-use-extension
 (byte-structure-description
  (reply              1)
  (supported          1)
  (sequence-number    2)
  (reply-length       4)
  (max-request-length 4)
  (padding            2) ))
(define-bs-accessors 'xbrrr-use-extension Xbr-rr-use-extension)
(define X-big-req-enable:template
 (let ((template (make-byte-string (bs-length Xbr-rp-use-extension))))
  (byte-string-clear! template)
  (xbrrp-use-extension:set-minor-opcode!   template (byte->byte-string     0))
  (xbrrp-use-extension:set-request-length! template (number->byte-string-2 1))
  template))
(define (X-big-req-enable connection opcode)
 (let ((t X-big-req-enable:template))
  (xbrrp-use-extension:set-opcode! t (byte->byte-string opcode))
  (X-request connection t (lambda (con fbw)
   (byte-string->number (xbrrr-use-extension:max-request-length fbw))))
))
)) ; closes xbr namespace
)) ; closes xext big requests class


