
   ;;   ;;   ;;     Graphical        Viper System Interface
 ;;     ;; ;;  ;;   Input                    SCA/X
 ;;  ;; ;; ;;  ;;   Output            Viper Object System
   ;;   ;;   ;;                  

;; DISPLAY These should be inner classes of the display-class
;; X Extension

(define xext-keyboard-class   (class (extension x-extension-class)
 (slots xdetail)

(method initialize (display) (super display "XKEYBOARD")
 (let* ((rr ((this display) rr) ))
   (this (set! 'xdetail (call xekb 'Xkb-use-extension (display connection) (this major-opcode))))
   (display (set! 'keyboard (make-object keyboard-class display this)))
   ; TODO install-error-handler (rr (install-handler (this first-error) (lambda (display fbw) (X-log-debug "XKBE unhandled error"))))
   (rr (install-handler (this first-event) ((display keyboard) (make-event-handler))))
   ((display keyboard) (activate-events))
))


(define xekb (namespace (namespace-import sca/x-common)
(define X-rp-use-extension ;; TODO use Xkb prefix instead of X
 (byte-structure-description
  (opcode         1)
  (minor-opcode   1)
  (request-length 2)
  (wanted-major   2)
  (wanted-minor   2)))
(define-bs-accessors 'xrp-use-extension X-rp-use-extension)
(define X-rr-use-extension
 (byte-structure-description
  (reply     1)
  (supported 1)
  (sequence-number 2)
  (reply-length    4)
  (server-major    2)
  (server-minor    2)
  (padding        20)))
(define-bs-accessors 'xrr-use-extension X-rr-use-extension)
(define Xkb-use-extension:template
 (let ((template (make-byte-string (bs-length X-rp-use-extension))))
  (byte-string-clear! template)
  (xrp-use-extension:set-minor-opcode!   template (byte->byte-string     0))
  (xrp-use-extension:set-request-length! template (number->byte-string-2 2))
  (xrp-use-extension:set-wanted-major!   template (number->byte-string-2 1))
  (xrp-use-extension:set-wanted-minor!   template (number->byte-string-2 0))
  template))
(define (Xkb-use-extension connection opcode)
 (let ((t Xkb-use-extension:template))
  (xrp-use-extension:set-opcode! t (byte->byte-string opcode))
  (X-request connection t (lambda (con fbw)
   (list (cons 'supported    (byte-string-true?   (xrr-use-extension:supported    fbw)))
         (cons 'server-major (byte-string->number (xrr-use-extension:server-major fbw)))
         (cons 'server-minor (byte-string->number (xrr-use-extension:server-minor fbw))) )))
))
)) ; closes xekb namespace
)) ; closes xext keyboard class

