
   ;;   ;;   ;;     Graphical        Viper System Interface
 ;;     ;; ;;  ;;   Input                    SCA/X
 ;;  ;; ;; ;;  ;;   Output            Viper Object System
   ;;   ;;   ;;                  

;; DISPLAY These should be inner classes of the display-class
;; X Extension


(define xext-shared-memory-class (class (extension x-extension-class)
 (slots has-shared-pixmaps major-version minor-version uid gid pixmap-format-id)
(method initialize (display) (super display "MIT-SHM")
 (let ((fbw (call xshm 'Xshm-query-version (display connection) (this major-opcode)))
       (rr  (display rr)))
  (this (set! 'has-shared-pixmaps (byte-string-true?   (fixed-call xshm 'xshm-rr-query-version:shared-pixmaps fbw))))
  (this (set! 'major-version      (byte-string->number (fixed-call xshm 'xshm-rr-query-version:major-version  fbw))))
  (this (set! 'minor-version      (byte-string->number (fixed-call xshm 'xshm-rr-query-version:minor-version  fbw))))
  (this (set! 'uid                (byte-string->number (fixed-call xshm 'xshm-rr-query-version:uid            fbw))))
  (this (set! 'gid                (byte-string->number (fixed-call xshm 'xshm-rr-query-version:gid            fbw))))
  (this (set! 'pixmap-format-id   (byte-string->number (fixed-call xshm 'xshm-rr-query-version:pixmap-format  fbw))))

  ; TODO install-error-handler (rr (install-handler (this first-error) (lambda (display fbw) (X-log-debug "XSHM unhandled error"))))
  (rr (install-handler (this first-event) (lambda (display fbw) (X-log-debug "XSHM unhandled event"))))
))

(define xshm (namespace (namespace-import sca/x-common)
(define Xshm-rp-query-version
 (byte-structure-description
  (major-opcode   1)
  (minor-opcode   1)
  (request-length 2)))
(define-bs-accessors 'xshm-rp-query-version Xshm-rp-query-version)
(define Xshm-query-version:template
 (let ((template (byte-string-clear! (make-byte-string (bs-length Xshm-rp-query-version)))))
  (xshm-rp-query-version:set-minor-opcode!   template (byte->byte-string     0))
  (xshm-rp-query-version:set-request-length! template (number->byte-string-2 1))
  template))
(define Xshm-rr-query-version
 (byte-structure-description
  (type            1)
  (shared-pixmaps  1)
  (sequence-number 2)
  (reply-length    4)
  (major-version   2)
  (minor-version   2)
  (uid             2)
  (gid             2)
  (pixmap-format   1) ;; 0 Bitmap 1 XYPixmap 2 ZPixmap (should always be two)
  (padding        15)))
(define-bs-accessors 'xshm-rr-query-version Xshm-rr-query-version)
(define (Xshm-query-version connection major-opcode)
 (let ((rb Xshm-query-version:template))
   (xshm-rp-query-version:set-major-opcode! rb (byte->byte-string major-opcode))
   (X-request connection rb (lambda (con fbw) fbw))))
)) ; closes xshm namespace
)) ; closes xext shared memory class
