
   ;;   ;;   ;;     Graphical        Viper System Interface
 ;;     ;; ;;  ;;   Input                    SCA/X
 ;;  ;; ;; ;;  ;;   Output            Viper Object System
   ;;   ;;   ;;                  


(sys-load "VSI-core/byte-structures.scm")
(sys-load "VOS/vos.scm")
;(sys-load "lib/queue.scm")

;;;
;;; PRELIMINARY GIO base classes
;;;

(define display-object-class   (class (extension viper-object-class)
  (slots display)
  (method initialize (display) (this (set! 'display display)))
))

(define display-resource-class (class (extension display-object-class)
 (slots rid)

 (method initialize (display) (super display)
   (this (set! 'rid ((display riddle) (register-object this)) )))

 (method destroy ()
  (((this display) riddle) (remove-id (this rid))))

 (method get-sid () (format "~A" (this rid)))
))

;;;
;;; Dependency Loader
;;;

(sys-load          "GIO/colors.scm")
(sys-load    "GIO/sca-x.common.scm")

(sys-load    "GIO/pixmap.class.scm")
(sys-load   "GIO/picture.class.scm")
(sys-load    "GIO/window.class.scm")
(sys-load "GIO/pointer-device.class.scm")
(sys-load     "GIO/event.class.scm")
(sys-load  "GIO/keyboard.class.scm")

(sys-load   "GIO/display/visual.class.scm")
(sys-load   "GIO/display/colormap.class.scm")
(sys-load   "GIO/display/screen.class.scm")
(sys-load   "GIO/display/x-extension.class.scm")
(sys-load   "GIO/display/x-extensions/xext-big-requests.class.scm")
(sys-load   "GIO/display/x-extensions/xext-keyboard.class.scm")
(sys-load   "GIO/display/x-extensions/xext-security.class.scm")
(sys-load   "GIO/display/x-extensions/xext-shared-memory.class.scm")
(sys-load   "GIO/display/x-extensions/xext-render.class.scm")
(sys-load   "GIO/display/x-shared-memory.class.scm")
(sys-load   "GIO/display.class.scm")

(sys-load        "GIO/gc.class.scm")
(sys-load      "GIO/font.class.scm")


;; Preliminary Widgets
(sys-load "GIO/flat-menu.class.scm")
(sys-load "GIO/label.class.scm")
(sys-load "GIO/itl.class.scm")


;; DONE check for eof in the channel handler to remove itsself
;; TODO and invalidate the display object as well as the compl dg
;;
;; TODO reflect the dg

(when (defined? 'sys-display) (error "GIO double load"))
(define sys-display (make-object display-class))

(define gio-font (make-object font-class sys-display
                              "-misc-fixed-medium-r-normal--20-140-100-100-c-100-iso8859-1"))
                              ;"-bitstream-bitstream charter-bold-r-normal--0-0-0-0-p-0-iso8859-1"))
                              ;"-urw-urw gothic l-semibold-r-normal--0-0-0-0-p-0-iso8859-1"))
;; (define gio-font (make-object font-class sys-display "-urw-urw gotic l-semibold-r-normal--0-0-0-0-p-0-iso8859-1"))
;;                                                                ^^^^^
;;  => throw catched: misc-error: "Window Sytem Error xrr query fonts 0"
;; Error recovery? false-if-exception might not be suited to recognize 0 as an undefined error code?
;;
