(define label-class (class                        (extension window-class)
 (slots label baseline indention)
 (slots reg-gc highlight-gc)

 (method initialize (label parent x y width border-width)
  (this (set! 'label label))
  (let* ((border-width 0)
         (dim (gio-font (line-metrics label)))
         ;(h-space (round (/ (- (menu width) (first dim)) 2)))
         ;0  1  2  3  4  5  6 
         ;__ __ __ __ __ __ __   integer steps 
         ;  .  .  .  .  .  .     exact halfs 
         ;   .  .  .  .  .  .    biased (regular) round  
         ;.     :     :     .    current round implementation (with overall error reduction) is problematic when it's about maintaining geometric patterns? 
                               ; Perhaps more complex examples might show the odd/even rounding
                               ; approach works as well for rasterization as the biased rounding. 
         (dim (gio-font (line-metrics "M")))
         (h-space (ceiling (* 6 (* 1/13 (first dim)))))
         (ascent  (gio-font ascent))
         (v-space (* 1/2 ascent 1/2))
         (v-space-b (floor   v-space))
         (v-space-u (ceiling v-space))
         (v-space (+ v-space-u v-space-b)))
    (super parent x y width (+ ascent v-space) border-width)
    (this (set! 'indention h-space))
    (this (set! 'baseline (+ ascent v-space-u))))
  (let ((gc1 (make-object graphics-context-class this))
        (gc2 (make-object graphics-context-class this)))
    (gc1 (set-font gio-font))
    (gc1 (set-color 'foreground white))
    (gc1 (set-color 'background (color-value (color-saturation vsiblue 1/8) 1/2)))
    (this (set! 'reg-gc gc1))
    (gc2 (set-font gio-font))
    (gc2 (set-color 'foreground white))
    (gc2 (set-color 'background black))
    ;(gc2 (set-color 'foreground white))
    ;(gc2 (set-color 'background black))
    (this (set! 'highlight-gc gc2))
  )

  (this (activate-events expose-event-class))
 )

 (method expose-event (event)
  ;(this (set! 'exposures (+ (this exposures) 1)))
  (when (= (event count) 0) ;(X-log-debug "label-exposure #" (this exposures)) (wait 20) (this (set! 'exposures 0))
    (this (draw))))

 (method draw ()
  ; (this (clear))
  (let ((gc (this reg-gc)))
   (gc (image-text-8 (this indention) (this baseline) (this label)))
 ))
)) ; closes label class
