
   ;;   ;;   ;;     Graphical        Viper System Interface
 ;;     ;; ;;  ;;   Input                    SCA/X
 ;;  ;; ;; ;;  ;;   Output            Viper Object System
   ;;   ;;   ;;                  

;;
;; Picture denotes a modern pixmap. 
;; Depends xext-render

(define picture-class (class                    (extension display-resource-class)
 (slots format)

(method initialize (drawable init . arguments) (let ((display (drawable display)))
 (super display)
 (this (set! 'format ((display root-visual) picture-format))) ; should be drawable -> visual -> picture-format
 (case init
 ((empty) ; no further arguments
 (fixed-call xrender 'create-picture (display connection)
                                     ((display xext-render) major-opcode)
                                     (this rid)
                                     (drawable rid)
                                     ((this format) rid)))
 ((filled) (let ((C (first arguments))) ;; XXX missing syntax checks
 (fixed-call xrender 'create-solid-fill (display connection)
                                        ((display xext-render) major-opcode)
                                        (this rid)
                                        (this (color->picsel C 1)))))
 ; (else some error message here
)
))

(method change-draw-mode (poliedge-mode poliprecision repetition-mode)
 (let ((display (this display)))
  (fixed-call xrender 'change-picture-draw-mode
                      (display connection)
                      ((display xext-render) major-opcode)
                      (this rid)
                      poliedge-mode
                      poliprecision
                      repetition-mode)
))
)) ; closes picture class
