
   ;;   ;;   ;;     Graphical        Viper System Interface
 ;;     ;; ;;  ;;   Input                    SCA/X
 ;;  ;; ;; ;;  ;;   Output            Viper Object System
   ;;   ;;   ;;                  

(define pointer-device-class (class              (extension display-object-class)

 ;; Button Events
 (method add-button-listener (listener)  ;; expects method /button-event/
  (when (not (is-a? listener window-class))
   (error (brass-append "GIO pointer-device-class add-button-listener:"
                        " argument needs to be an area of interest aka window")))
  (listener (activate-events button-event-class))
 )
 (method remove-button-listener (listener)
  (when (not (is-a? listener window-class))
   (error (brass-append "GIO pointer-device-class remove-button-listener:"
                        " argument needs to be an area of interest aka window")))
  (listener (deactivate-events button-event-class))
 )

 ;; Motion Enter/Leave Events
 (method add-motion-enter-listener (listener)  ;; expects method /motion-enter-event/
  (when (not (is-a? listener window-class))
   (error (brass-append "GIO pointer-device-class add-motion-enter-listener:"
                        " argument needs to be an area of interest aka window")))
  (listener (activate-events motion-enter-event-class))
  )
 (method remove-motion-enter-listener (listener)
  (when (not (is-a? listener window-class))
   (error (brass-append "GIO pointer-device-class remove-motion-enter-listener:"
                        " argument needs to be an area of interest aka window")))
  (listener (deactivate-events motion-enter-event-class))
  )

 (method add-motion-leave-listener (listener)  ;; expects method /motion-leave-event/
  (when (not (is-a? listener window-class))
   (error (brass-append "GIO pointer-device-class add-motion-leave-listener:"
                        " argument needs to be an area of interest aka window")))
  (listener (activate-events motion-leave-event-class))
  )
 (method remove-motion-leave-listener (listener)
  (when (not (is-a? listener window-class))
   (error (brass-append "GIO pointer-device-class remove-motion-leave-listener:"
                        " argument needs to be an area of interest aka window")))
  (listener (deactivate-events motion-leave-event-class))
  )

 ;; Motion Events
 (method add-motion-listener (listener)  ;; expects method /motion-event/
  (when (not (is-a? listener window-class))
   (error (brass-append "GIO pointer-device-class add-motion-listener:"
                        " argument needs to be an area of interest aka window")))
  (listener (activate-events motion-event-class))
 )
 (method remove-motion-listener (listener)
  (when (not (is-a? listener window-class))
   (error (brass-append "GIO pointer-device-class remove-motion-listener:"
                        " argument needs to be an area of interest aka window")))
  (listener (deactivate-events motion-event-class))
 )
)) ; closes pointer device class
