;;
;;    Viper
;;   Object
;;  System     Everything you need for Viper Objects
;;


(when (not (defined? 'class))
  (sys-load "VOS/vo.scm"))

(when (not (defined? 'sys-control))
  (sys-load "VOS/voc.scm")
  (define sys-control  (make-object control-class)))

(when (not (defined? 'sys-parallel))
  (sys-load "VOS/vop.scm")
  (define sys-parallel (make-object parallel-class)))

(when (not (defined? 'sys-terminal))
  (when (not (defined? 'sys-unicode-namespace))
    (define sys-unicode-namespace (namespace (sys-load "lib/uc.scm")) ))
  (sys-load "VOS/vot.scm")
  (define sys-terminal (make-object terminal-class)))


;;; PS Conventions
;;
;; No bangs in message passing.
;;
;; Indention isn't useful across pages of screens full
;; of source expressions. The regular text structuring
;; techniques (TOC, headlines and references) should
;; suffice. Some unexpected default pattern for classes:
;;     I) slots
;;    II) methods
;;   III) definitions and namespaces
;;
;;; Exceptions can occur.
;;
;; Direct slot access is possible but remains direct slot
;; access.
;;
;; Accessors are often prefixed with /get-/ and /set-/.
;;
;; Current Practice in GIO
;;
;; /describe/ in conjunction with some logging routine might
;; become the default replacement where /display/ was used to
;; represent objects. It usually shouldn't recurse, though. (<- see GIO)
;;
;; /get-sid/ should provide a unique identifier representing
;;  a memory object: currently the byte string serialization
;;  of the X resource identifier where applicable. This is
;;  useful to stop recursion of memory object descriptions.
;;
;; Both /describe/ and /get-sid/ return a brass.
;;
;;;
