(define xi "
          ;;    ;;  ;;
           ;;  ;;   ;;    XI
             ;;Interactive Interpreter
           ;;  ;;   ;;
          ;;    ;;  ;;
")

;; TODO allow for interrupts (termios / sys-control)
;; TODO use an evaluation parallel combining subservice and parallels
;; There's also Examples/line-eval.scm which is even more simplistic:
;;  a (system "vsi bernstein.scm") will make it hang forever.

(sys-load "VOS/vos.scm")
(sys-load "Viper/itl.class.scm")
(sys-load "VSI-core/repl.scm")

(define xi-class (class (extension viper-object-class)
 (slots itl)

 (method initialize ()
  (this (set! 'itl (make-object itl-class 1 1 60)))
  ((this itl) (add-event-listener this))
 )

 (method start ()
  (sys-terminal (position-cursor 1 2)) (sys-terminal (save-cursor))
  ((this itl) (attach))
  (clr)
  (sys-terminal (tty-raw-mode))
  (make-object xi-class)
  (sys-control (roll))
  (repl-drain-input (sys-terminal port))
 )

 (method interpret-text (string)
  (sys-terminal (tty-cooked-mode))
  (sys-terminal (restore-cursor))
  (catch #t (lambda ()
  (let ((source '(repl-transcript)))
   (with-input-from-string string (lambda ()
    (let loop ((exp (read)))
     (when (not (eof-object? exp))
      (set! source (cons exp source))
      (loop (read)) )) ))
   (eval (reverse source) '() )))
  repl-error-handler)
  (sys-terminal (save-cursor))
  (sys-terminal (tty-raw-mode))
  ((this itl) (set-string ""))
  ((this itl) (force-draw)))

  ;; ITL Event Interface
  (method input-ready (string) (this (interpret-text string)))
))

(define (xit)
 (sys-terminal (tty-cooked-mode))
 (sys-terminal (erase-display))
 (sys-terminal (cursor-home))
 (primitive-exit 0)
)

(define (clr)
 (repl-clear)
 (sys-terminal (save-cursor))
 (sys-terminal (position-cursor 1 5))
 (display xi   (sys-terminal port))
 (sys-terminal (restore-cursor)))
