#include "include/config.h"

#ifdef HAVE_STRING_H
#include <string.h>
#endif

#include "include/_scm.h"
#include "include/root.h"
#include "include/nature.h"
#include "include/validate.h"

#include "include/feature.h"


static SCM features_var = 0;

void
scm_add_feature (const char *str)
{
  SCM old = SCM_VARIABLE_REF (features_var);
  SCM new = scm_cons (scm_from_locale_symbol (str), old);
  SCM_VARIABLE_SET (features_var, new);
}

void
x_inclusion_feature ()
{
  features_var = scm_c_define ("*features*", SCM_EOL);
  rc_declare_data_graph_root (features_var);

  scm_add_feature("system");
#ifdef SICP /* mt: I don't think this is useful but don't use it - read it!
                   (And work through it - it's worth it). */
  scm_add_feature("sicp:" SICP); /* ;-) */
#endif
  scm_add_feature("char-ready?");
  scm_c_define ("char-code-limit", scm_from_int (SCM_CHAR_CODE_LIMIT));

#include "include/feature.x"
}
