// Strings & Brass

// #include "include/_scm.h"
#include "include/ihub.h"
#include <X11/X.h>
#include <X11/Xlib.h>
#include <X11/Xauth.h>

#include "include/byte-strings.h"
// low level SCA/X support
// XXX replace this in Scheme as soon as we are "certified"
SCM_DEFINE (scm_x_authentications, "x-authentications", 0, 0, 0, (), "")
#define FUNC_NAME s_scm_x_authentications
{
  char *file_name = XauFileName ();
  FILE *file = fopen (file_name, "r");

  if (file) {
    SCM sfile = scm_from_sen (file_name, strlen (file_name));
    SCM answer_box = scm_cons (sfile, SCM_EOL);
    reference_parameter (answer_box);
    SCM last = answer_box;
    Xauth *xau_data = NULL;

    while ((xau_data = XauReadAuth (file))) {
      // That's even more casting than in the byte word routines :-/
      SCM sfamily = scm_make_byte_string_with_copy \
        ((void*)&(xau_data->family), sizeof (short));
      SCM saddress = scm_make_byte_string_with_copy \
        ((void*)(xau_data->address), (size_t) xau_data->address_length);
      SCM snumber = scm_make_byte_string_with_copy \
        ((void*)(xau_data->number),  (size_t) xau_data->number_length);
      SCM sdata = scm_make_byte_string_with_copy \
        ((void*)(xau_data->data),    (size_t) xau_data->data_length);

      SCM entry = scm_list_4 (sfamily, saddress, snumber, sdata);
      scm_set_cdr_x (last, scm_cons (entry, SCM_EOL));
      last = TMP_CDR (last);
      XauDisposeAuth (xau_data);
    }
    fclose (file);
    answer_box = FLY_CDR (answer_box);
    return (rc_return_stack_reference (answer_box));
  }
  
  return (SCM_BOOL_F);
}
#undef FUNC_NAME

void
scm_init_gio ()
{
}

void
x_inclusion_gio ()
{
  #include "include/gio.x"
}
