#define SCM_BRASSP(x) (!SCM_IMP(x) && (SCM_TYP7(x)==scm_tc7_brass))

#define BR_LENGTH(x)  ((size_t) SCM_CELL_WORD_0(x))
#define BR_CHARS(x)   ((uint32_t*) (SCM_CELL_OBJECT_LOC(x, 1)))
#define BR_REF(x,n)   ((BR_CHARS(x))[(n)])
#define BR_SET(x,n,u) ((BR_CHARS(x))[(n)]=(u))

int scm_is_brass (SCM x);

SCM scm_brass_p (SCM x);
SCM scm_brass_equal_p (SCM a, SCM b);
SCM scm_brass (SCM chrs);
SCM scm_make_brass (SCM k, SCM chr);
SCM scm_brass_length (SCM br);
// SCM scm_brass_ref (SCM br, SCM k);
// SCM scm_brass_set_x (SCM br, SCM k, SCM chr);
SCM scm_subrass (SCM br, SCM start, SCM end);
SCM scm_brass_copy (SCM br);
SCM scm_brass_append (SCM args);

SCM scm_i_copy_brass (SCM br);
SCM scm_c_make_brass (size_t len);
SCM scm_c_make_brass_with_copy (usv_t *usv, size_t len);

SCM scm_brass_to_list (SCM br);

// no extra zero padding
SCM scm_brass_to_c0_byte_string (SCM br);
SCM scm_brass_to_byte_string_utf8 (SCM br);

// implicit extra zero padding
SCM scm_brass_to_c0_byte_stringz (SCM br);
SCM scm_brass_to_byte_string_utf8z (SCM br);

// automatic zero padding handling
SCM scm_byte_string_to_brass_utf8 (SCM br);
SCM utf8_to_brass (const char *string, size_t num_bytes);  // in uc.c

// System Encoding transitional (fixed as is)
#define scm_from_sen  utf8_to_brass
#define scm_to_sen    scm_brass_to_byte_string_utf8z 
SCM scm_from_cen (const char*);
SCM scm_makfromstrs (int argc, char **argv);  // oldtimer

// Port Encoding preliminary (is w/o zero byte)
#define scm_to_pen    scm_brass_to_byte_string_utf8
#define scm_from_pen  scm_byte_string_to_brass_utf8


void x_inclusion_brass ();


// Symbol Crafting Support

#define ODD_P(x)  ((x) & 1)
#define EVEN_P(x) (!ODD_P(x))

size_t BR_NSLOTS (size_t c_len);
