
// Number+Sign -> Byte String

SCM_DEFINE (scm_signed_number_to_8byte_string, "number+sign->byte-string-8",
            1, 0, 0, (SCM integer), "")
#define FUNC_NAME s_scm_signed_number_to_8byte_string
{
  #define MY_TYPE scm_t_int64
  #define MY_CONV scm_to_int64

  reference_parameter (integer);

  if (SCM_NUMBERP (integer)) {
    MY_TYPE num = MY_CONV (integer);
    size_t length = sizeof (MY_TYPE);
    SCM answer = scm_c_make_byte_string (length);
    void *data_segment = BYTE_STRING_DATA (answer);
    *((MY_TYPE *)data_segment) = num;
    dereference_parameter (integer);
    return (answer);

  } else {
    scm_wrong_type_arg_msg (FUNC_NAME, 0, integer, "integer");
    return SCM_BOOL_F;
  }
  // never reached
  dereference_parameter (integer);
  return SCM_UNSPECIFIED;

  #undef MY_TYPE
  #undef MY_CONV
}
#undef FUNC_NAME

SCM_DEFINE (scm_signed_number_to_4byte_string, "number+sign->byte-string-4",
            1, 0, 0, (SCM integer), "")
#define FUNC_NAME s_scm_signed_number_to_4byte_string
{
  #define MY_TYPE scm_t_int32
  #define MY_CONV scm_to_int32

  reference_parameter (integer);

  if (SCM_NUMBERP (integer)) {
    MY_TYPE num = MY_CONV (integer);
    size_t length = sizeof (MY_TYPE);
    SCM answer = scm_c_make_byte_string (length);
    void *data_segment = BYTE_STRING_DATA (answer);
    *((MY_TYPE *)data_segment) = num;
    dereference_parameter (integer);
    return (answer);

  } else {
    scm_wrong_type_arg_msg (FUNC_NAME, 0, integer, "integer");
    return SCM_BOOL_F;
  }
  // never reached
  dereference_parameter (integer);
  return SCM_UNSPECIFIED;

  #undef MY_TYPE
  #undef MY_CONV
}
#undef FUNC_NAME

SCM_DEFINE (scm_signed_number_to_2byte_string, "number+sign->byte-string-2",
            1, 0, 0, (SCM integer), "")
#define FUNC_NAME s_scm_signed_number_to_2byte_string
{
  #define MY_TYPE scm_t_int16
  #define MY_CONV scm_to_int16

  reference_parameter (integer);

  if (SCM_NUMBERP (integer)) {
    MY_TYPE num = MY_CONV (integer);
    size_t length = sizeof (MY_TYPE);
    SCM answer = scm_c_make_byte_string (length);
    void *data_segment = BYTE_STRING_DATA (answer);
    *((MY_TYPE *)data_segment) = num;
    dereference_parameter (integer);
    return (answer);

  } else {
    scm_wrong_type_arg_msg (FUNC_NAME, 0, integer, "integer");
    return SCM_BOOL_F;
  }
  // never reached
  dereference_parameter (integer);
  return SCM_UNSPECIFIED;

  #undef MY_TYPE
  #undef MY_CONV
}
#undef FUNC_NAME

SCM_DEFINE (scm_signed_byte_to_byte_string, "byte+sign->byte-string",
           1, 0, 0, (SCM integer), "")
#define FUNC_NAME s_scm_signed_byte_to_byte_string
{
  #define MY_TYPE scm_t_int8
  #define MY_CONV scm_to_int8

  reference_parameter (integer);

  if (SCM_NUMBERP (integer)) {
    MY_TYPE num = MY_CONV (integer);
    size_t length = sizeof (MY_TYPE);
    SCM answer = scm_c_make_byte_string (length);
    void *data_segment = BYTE_STRING_DATA (answer);
    *((MY_TYPE *)data_segment) = num;
    dereference_parameter (integer);
    return (answer);

  } else {
    scm_wrong_type_arg_msg (FUNC_NAME, 0, integer, "integer");
    return SCM_BOOL_F;
  }
  // never reached
  dereference_parameter (integer);
  return SCM_UNSPECIFIED;

  #undef MY_TYPE
  #undef MY_CONV
}
#undef FUNC_NAME


// Number -> Byte String

SCM_DEFINE (scm_number_to_8byte_string, "number->byte-string-8",
            1, 0, 0, (SCM integer), "")
#define FUNC_NAME s_scm_number_to_8byte_string
{
  #define MY_TYPE scm_t_uint64
  #define MY_CONV scm_to_uint64

  reference_parameter (integer);

  if (SCM_NUMBERP (integer)) {
    MY_TYPE num = MY_CONV (integer);
    size_t length = sizeof (MY_TYPE);
    SCM answer = scm_c_make_byte_string (length);
    void *data_segment = BYTE_STRING_DATA (answer);
    *((MY_TYPE *)data_segment) = num;
    dereference_parameter (integer);
    return (answer);

  } else {
    scm_wrong_type_arg_msg (FUNC_NAME, 0, integer, "integer");
    return SCM_BOOL_F;
  }
  // never reached
  dereference_parameter (integer);
  return SCM_UNSPECIFIED;

  #undef MY_TYPE
  #undef MY_CONV
}
#undef FUNC_NAME

SCM_DEFINE (scm_number_to_4byte_string, "number->byte-string-4",
            1, 0, 0, (SCM integer), "")
#define FUNC_NAME s_scm_number_to_4byte_string
{
  #define MY_TYPE scm_t_uint32
  #define MY_CONV scm_to_uint32

  reference_parameter (integer);

  if (SCM_NUMBERP (integer)) {
    MY_TYPE num = MY_CONV (integer);
    size_t length = sizeof (MY_TYPE);
    SCM answer = scm_c_make_byte_string (length);
    void *data_segment = BYTE_STRING_DATA (answer);
    *((MY_TYPE *)data_segment) = num;
    dereference_parameter (integer);
    return (answer);

  } else {
    scm_wrong_type_arg_msg (FUNC_NAME, 0, integer, "integer");
    return SCM_BOOL_F;
  }
  // never reached
  dereference_parameter (integer);
  return SCM_UNSPECIFIED;

  #undef MY_TYPE
  #undef MY_CONV
}
#undef FUNC_NAME

SCM_DEFINE (scm_number_to_2byte_string, "number->byte-string-2",
            1, 0, 0, (SCM integer), "")
#define FUNC_NAME s_scm_number_to_2byte_string
{
  #define MY_TYPE scm_t_uint16
  #define MY_CONV scm_to_uint16

  reference_parameter (integer);

  if (SCM_NUMBERP (integer)) {
    MY_TYPE num = MY_CONV (integer);
    size_t length = sizeof (MY_TYPE);
    SCM answer = scm_c_make_byte_string (length);
    void *data_segment = BYTE_STRING_DATA (answer);
    *((MY_TYPE *)data_segment) = num;
    dereference_parameter (integer);
    return (answer);

  } else {
    scm_wrong_type_arg_msg (FUNC_NAME, 0, integer, "integer");
    return SCM_BOOL_F;
  }
  // never reached
  dereference_parameter (integer);
  return SCM_UNSPECIFIED;

  #undef MY_TYPE
  #undef MY_CONV
}
#undef FUNC_NAME

SCM_DEFINE (scm_byte_to_byte_string, "byte->byte-string",
           1, 0, 0, (SCM integer), "")
#define FUNC_NAME s_scm_byte_to_byte_string
{
  #define MY_TYPE scm_t_uint8
  #define MY_CONV scm_to_uint8

  reference_parameter (integer);

  if (SCM_NUMBERP (integer)) {
    MY_TYPE num = MY_CONV (integer);
    size_t length = sizeof (MY_TYPE);
    SCM answer = scm_c_make_byte_string (length);
    void *data_segment = BYTE_STRING_DATA (answer);
    *((MY_TYPE *)data_segment) = num;
    dereference_parameter (integer);
    return (answer);

  } else {
    scm_wrong_type_arg_msg (FUNC_NAME, 0, integer, "integer");
    return SCM_BOOL_F;
  }
  // never reached
  dereference_parameter (integer);
  return SCM_UNSPECIFIED;

  #undef MY_TYPE
  #undef MY_CONV
}
#undef FUNC_NAME


// Byte String -> Number

SCM_DEFINE (scm_byte_string_to_number, "byte-string->number", 1, 0, 0,
            (SCM byte_string), "")
#define FUNC_NAME s_scm_byte_string_to_number
{
  reference_parameter (byte_string);

  if (!BYTE_STRING_P (byte_string))
    scm_wrong_type_arg_msg (FUNC_NAME, 0, byte_string, "byte-string");

  SCM answer;
  size_t length = BYTE_STRING_LENGTH (byte_string);
  switch (length) {
  case 8:
    answer = \
      scm_from_uint64 (*((scm_t_uint64*)BYTE_STRING_DATA (byte_string)));
    break;
  case 4:
    answer = \
      scm_from_uint32 (*((scm_t_uint32*)BYTE_STRING_DATA (byte_string)));
    break;
  case 2:
    answer = \
      scm_from_uint16 (*((scm_t_uint16*)BYTE_STRING_DATA (byte_string)));
    break;
  case 1:
    answer = \
      scm_from_uint8  (*((scm_t_uint8*) BYTE_STRING_DATA (byte_string)));
    break;
  default:
    scm_out_of_range (FUNC_NAME, SCM_BOOL_F);
  }

  dereference_parameter (byte_string);
  return (answer);
}
#undef FUNC_NAME

SCM_DEFINE (scm_byte_string_to_signed_number,
            "byte-string->number+sign", 1, 0, 0, (SCM byte_string), "")
#define FUNC_NAME s_scm_byte_string_to_signed_number
{
  reference_parameter (byte_string);

  if (!BYTE_STRING_P (byte_string))
    scm_wrong_type_arg_msg (FUNC_NAME, 0, byte_string, "byte-string");

  SCM answer;
  size_t length = BYTE_STRING_LENGTH (byte_string);
  switch (length) {
  case 8:
    answer = \
      scm_from_int64 (*((scm_t_int64*)BYTE_STRING_DATA (byte_string)));
    break;
  case 4:
    answer = \
      scm_from_int32 (*((scm_t_int32*)BYTE_STRING_DATA (byte_string)));
    break;
  case 2:
    answer = \
      scm_from_int16 (*((scm_t_int16*)BYTE_STRING_DATA (byte_string)));
    break;
  case 1:
    answer = \
      scm_from_int8  (*((scm_t_int8*) BYTE_STRING_DATA (byte_string)));
    break;
  default:
    scm_out_of_range (FUNC_NAME, SCM_BOOL_F);
  }

  dereference_parameter (byte_string);
  return (answer);
}
#undef FUNC_NAME

