/* classes: h_files */

#ifndef SCM_CHARS_H
#define SCM_CHARS_H
#include "include/__scm.h"


/* Immediate Characters
 */
#define SCM_CHARP(x) (SCM_ITAG8(x) == scm_tc8_char)
#define SCM_CHAR(x) ((uint32_t)SCM_ITAG8_DATA(x))

// TODO use prototyped function calls to control type correctness
// !!! These casts are silent.
#define SCM_MAKE_CHAR(x) SCM_MAKE_ITAG8((scm_t_bits) ((unsigned char) (x)), scm_tc8_char)
// XXX transitional
#define SCM_MAKE_UC_CHAR(x) SCM_MAKE_ITAG8((scm_t_bits) (x), scm_tc8_char)


SCM scm_charname_lookup (SCM brass);
int scm_n_charnames;
extern const char *scm_charnames[];
extern const char scm_charnums[];



SCM scm_char_p (SCM x);
SCM scm_char_eq_p (SCM x, SCM y);
SCM scm_char_less_p (SCM x, SCM y);
SCM scm_char_leq_p (SCM x, SCM y);
SCM scm_char_gr_p (SCM x, SCM y);
SCM scm_char_geq_p (SCM x, SCM y);
/* SCM scm_char_alphabetic_p (SCM chr); */
/* SCM scm_char_numeric_p (SCM chr); */
/* SCM scm_char_whitespace_p (SCM chr); */
/* SCM scm_char_upper_case_p (SCM chr); */
/* SCM scm_char_lower_case_p (SCM chr); */
/* SCM scm_char_is_both_p (SCM chr); */
SCM scm_char_to_integer (SCM chr);
SCM scm_integer_to_char (SCM n);
int scm_c_upcase (unsigned int c);
int scm_c_downcase (unsigned int c);
void scm_init_chars (void);

// Unicode Addendum
SCM utf8_usv_to_bs (uint32_t usv);
SCM utf8_read_char (SCM port);
SCM utf8_usv_num_bytes (uint32_t usv);
SCM utf8_usv_to_bytes (uint32_t usv, uint8_t *utf);  // private

#endif  /* SCM_CHARS_H */
