/* classes: h_files */

#ifndef SCM_DEBUG_H
#define SCM_DEBUG_H
#include "include/__scm.h"


void scm_i_display_error (SCM unused, SCM port, SCM subr,
                          SCM message, SCM args, SCM rest);

SCM scm_global_object_counts ();
void debug_print_system_info (char **argv);
void debug_print_smob_info ();
void scm_init_debug (void);
void x_inclusion_debug (void);

SCM scm_procedure_name (SCM proc);
SCM scm_procedure_source (SCM proc);
SCM scm_procedure_environment (SCM environment);

/*
 * Counts & Ticks
 */

/* Object Counts */
long global_number_of_pairs;
long global_last_number_of_pairs;

long global_number_of_vectors;
long global_last_number_of_vectors;

long global_number_of_brass;

long global_number_of_byte_strings;
long global_number_of_byte_string_mappings;

long global_number_of_variables;
long global_last_number_of_variables;

unsigned long global_number_of_symbols_created;
unsigned long global_last_number_of_symbols;

long global_number_of_closures;
long global_last_number_of_closures;

long global_number_of_ports;

long global_number_of_reals;
long global_number_of_complex;
long global_number_of_bignums;
long global_number_of_fractions;

/* Direct Smob Count Links */
long *global_winder_count;
long *global_frame_count;
long *global_jmpbuffer_count;
long *global_pre_unwind_data_count;


/* Color Code Profiling Call Counts (Compile Time Temporaries) */
long global_color_counter_green;
long global_color_counter_blu;
long global_color_counter_red;
long global_color_counter_violet;
long global_color_counter_yellow;

/* Call Counts: fuel counters tick with calls to acons for now */
unsigned long global_counter_non_phalanx;
unsigned long global_counter_objprop_fuel;
unsigned long global_counter_procprop_fuel;
unsigned long global_counter_debug_fuel;
unsigned long global_counter_dynwind_fuel;
unsigned long global_counter_ceval_fuel;

/* TRIM statistics */
unsigned long global_counter_reinsertions;
unsigned long global_counter_drops;
unsigned long global_cell_segments;
unsigned long global_double_cell_segments;

#endif  /* SCM_DEBUG_H */
