#include "include/alist.h"

/*
 * Dinosaur Data Type
 */

/*
 * Dictionary
 */ 
#define SCM_IS_DICTIONARY(x) (!SCM_IMP(x) && (SCM_TYP7(x)==scm_tc7_dictionary))
#define SCM_DICTIONARY_ROOT(x) (SCM_CELL_OBJECT_1(x))

SCM scm_make_dictionary ();
SCM scm_dictionary_p    ();
SCM scm_dictionary_root ();


/*
 * Entry
 */

#define MAKE_ENTRY(key,definition,successors) \
  (scm_i_cons ((key), scm_i_cons ((definition),(successors))))
#define GET_KEY(entry)        (TMP_CAR(entry))
#define GET_DEFINITION(entry) (TMP_CADR(entry))
#define GET_SUCCESSORS(entry) (TMP_CDDR(entry))
#define SET_DEFINITION_X(entry,definition) \
  (SCM_SETCAR (TMP_CDR(entry),(definition)))

#define scm_get_successor(entry,key) \
  (scm_assq_unchecked_lax (key, GET_SUCCESSORS (entry)))

SCM scm_make_dict_entry (SCM key, SCM definition, SCM successors);

SCM scm_i_get_entry_by_usv (SCM branch, usv_t *keys, size_t length);
SCM scm_i_create_entry_by_usv_x (SCM parent, usv_t *keys, size_t length);

/* SCM initialization interface */
void x_inclusion_dictionary ();
