/* classes: h_files */

#ifndef SCM_DYNWIND_H
#define SCM_DYNWIND_H
#include "include/__scm.h"



typedef void (*scm_t_guard) (void *);
typedef SCM (*scm_t_inner) (void *);

SCM scm_dynamic_wind (SCM thunk1, SCM thunk2, SCM thunk3);
void scm_dowinds (SCM to, long delta);

SCM global_dynwinds_box;
#define scm_i_dynwinds()         (scm_cdr (global_dynwinds_box))
// SCM debug_dynwinds ();
// #define scm_i_dynwinds        debug_dynwinds
#define scm_i_set_dynwinds(w)    (scm_set_cdr_x (global_dynwinds_box, (w)))

void scm_init_dynwind (void);
void x_inclusion_dynwind (void);

void scm_swap_bindings (SCM vars, SCM vals);

typedef enum {
  SCM_F_DYNWIND_REWINDABLE = (1 << 0) /* XXX ... just not understand 'em ..*/
} scm_t_dynwind_flags;

typedef enum {
  SCM_F_WIND_EXPLICITLY = (1 << 0) /* XXX ... just not understand 'em ..*/
} scm_t_wind_flags;

SCM scm_dynwind_begin (scm_t_dynwind_flags);
void scm_dynwind_end (SCM);

void scm_dynwind_unwind_handler (void (*func) (void *), void *data,
					 scm_t_wind_flags);
void scm_dynwind_rewind_handler (void (*func) (void *), void *data,
					 scm_t_wind_flags);

void scm_dynwind_free (void *mem);

#ifdef GUILE_DEBUG
SCM scm_wind_chain (void);
#endif /*GUILE_DEBUG*/

/* Frames and winders. */

scm_t_tag tc16_frame;
#define FRAME_P(f)     SCM_SMOB_PREDICATE (tc16_frame, (f))

#define FRAME_F_REWINDABLE    (1 << 0)
#define FRAME_REWINDABLE_P(f) (SCM_SMOB_FLAGS(f) & FRAME_F_REWINDABLE)

scm_t_tag tc16_winder;
#define WINDER_P(w)     SCM_SMOB_PREDICATE (tc16_winder, (w))
#define WINDER_PROC(w)  ((void (*)(void *))SCM_SMOB_DATA (w))
#define WINDER_DATA(w)  ((void *)SCM_SMOB_DATA_2 (w))

#define WINDER_F_EXPLICIT    (1 << 0)
#define WINDER_F_REWIND      (1 << 1)
#define WINDER_F_MARK        (1 << 2)
#define WINDER_EXPLICIT_P(w) (SCM_SMOB_FLAGS(w) & WINDER_F_EXPLICIT)
#define WINDER_REWIND_P(w)   (SCM_SMOB_FLAGS(w) & WINDER_F_REWIND)
#define WINDER_MARK_P(w)     (SCM_SMOB_FLAGS(w) & WINDER_F_MARK)

#endif  /* SCM_DYNWIND_H */
