/* classes: h_files */

#ifndef SCM_ERROR_H
#define SCM_ERROR_H
#include "include/__scm.h"


SCM scm_system_error_key;
SCM scm_num_overflow_key;
SCM scm_out_of_range_key;
SCM scm_out_of_memory_key;
SCM scm_args_number_key;
SCM scm_arg_type_key;
SCM scm_memory_alloc_key;
SCM scm_misc_error_key;



void scm_error (SCM key, const char *subr, const char *message,
			SCM args, SCM rest) SCM_NORETURN;
SCM scm_error_scm (SCM key, SCM subr, SCM message,
			   SCM args, SCM rest) SCM_NORETURN;
SCM scm_strerror (SCM err);
void scm_syserror (const char *subr) SCM_NORETURN;
void scm_syserror_msg (const char *subr, const char *message,
			       SCM args, int eno) SCM_NORETURN;
void scm_num_overflow (const char *subr) SCM_NORETURN;
void scm_out_of_memory () SCM_NORETURN;
void scm_out_of_range (const char *subr, SCM bad_value)
     SCM_NORETURN;
void scm_out_of_range_pos (const char *subr, SCM bad_value, SCM pos)
     SCM_NORETURN;
void scm_wrong_num_args (SCM proc) SCM_NORETURN;
void scm_error_num_args_subr (const char* subr) SCM_NORETURN;
void scm_wrong_type_arg (const char *subr, int pos,
				 SCM bad_value) SCM_NORETURN;
void scm_wrong_type_arg_msg (const char *subr, int pos,
				     SCM bad_value, const char *sz) SCM_NORETURN;
void scm_memory_error (const char *subr) SCM_NORETURN;
void scm_misc_error (const char *subr, const char *message,
			     SCM args) SCM_NORETURN;
void scm_encoding_error (const char *details) SCM_NORETURN;
void scm_init_error (void);

#endif  /* SCM_ERROR_H */
