/* classes: h_files */

#ifndef SCM_FPORTS_H
#define SCM_FPORTS_H
#include "include/__scm.h"

#include "include/ports.h"



/* struct allocated for each buffered FPORT.  */
typedef struct scm_t_fport {
  int fdes;			/* file descriptor.  */
} scm_t_fport;

scm_t_tag scm_tc16_fport;

#define SCM_FSTREAM(x) ((scm_t_fport *) SCM_STREAM (x))
#define SCM_FPORT_FDES(x) (SCM_FSTREAM (x)->fdes)

#define SCM_FPORTP(x) (!SCM_IMP (x) && (SCM_TYP16 (x) == scm_tc16_fport))
#define SCM_OPFPORTP(x) (SCM_FPORTP (x) && (SCM_CELL_WORD_0 (x) & SCM_OPN))
#define SCM_OPINFPORTP(x) (SCM_OPFPORTP (x) && (SCM_CELL_WORD_0 (x) & SCM_RDNG))
#define SCM_OPOUTFPORTP(x) (SCM_OPFPORTP (x) && (SCM_CELL_WORD_0 (x) & SCM_WRTNG))

/* test whether fdes supports random access.  */
#define SCM_FDES_RANDOM_P(fdes) ((lseek (fdes, 0, SEEK_CUR) == -1) ? 0 : 1)


SCM scm_setbuf0 (SCM port);
SCM scm_setvbuf (SCM port, SCM mode, SCM size);
SCM scm_open_file (SCM filename, SCM modes);
SCM scm_fdes_to_port (int fdes, char *mode, SCM name);
SCM scm_file_port_p (SCM obj);
void scm_init_fports (void);
void x_inclusion_fports (void);

/* internal functions */

SCM scm_i_fdes_to_port (int fdes, long mode_bits, SCM name);
int scm_i_fport_truncate (SCM, SCM);
SCM scm_i_fport_seek (SCM, SCM, int);


#endif  /* SCM_FPORTS_H */
