/* classes: h_files */

#ifndef SCM_ISELECT_H
#define SCM_ISELECT_H
#include "include/__scm.h"

/* Needed for FD_SET on some systems.  */
#include <sys/types.h>

#if SCM_HAVE_SYS_SELECT_H
# include <sys/select.h>
#endif

#if SCM_HAVE_WINSOCK2_H
# include <winsock2.h>
#endif

#ifdef FD_SET

#define SELECT_TYPE fd_set
#if defined(__INTERIX) && FD_SETSIZE == 4096
/* Interix defines FD_SETSIZE 4096 but select rejects that. */
#define SELECT_SET_SIZE 1024
#else
#define SELECT_SET_SIZE FD_SETSIZE
#endif

#else /* no FD_SET */

/* Define the macros to access a single-int bitmap of descriptors.  */
#define SELECT_SET_SIZE 32
#define SELECT_TYPE int
#define FD_SET(n, p) (*(p) |= (1 << (n)))
#define FD_CLR(n, p) (*(p) &= ~(1 << (n)))
#define FD_ISSET(n, p) (*(p) & (1 << (n)))
#define FD_ZERO(p) (*(p) = 0)

#endif /* no FD_SET */

int scm_std_select (int fds,
                    SELECT_TYPE *rfds,
                    SELECT_TYPE *wfds,
                    SELECT_TYPE *efds,
                    struct timeval *timeout);

#endif  /* SCM_ISELECT_H */
