/* classes: h_files */

#ifndef SCM_LIST_H
#define SCM_LIST_H
#include "include/__scm.h"



SCM scm_list_1 (SCM e1);
SCM scm_list_2 (SCM e1, SCM e2);
SCM scm_list_3 (SCM e1, SCM e2, SCM e3);
SCM scm_list_4 (SCM e1, SCM e2, SCM e3, SCM e4);
SCM scm_list_5 (SCM e1, SCM e2, SCM e3, SCM e4, SCM e5);
SCM scm_list_n (SCM elt, ...);
SCM scm_list (SCM objs);
SCM scm_list_head (SCM lst, SCM k);
SCM scm_make_list (SCM n, SCM init);
SCM scm_cons_star (SCM arg, SCM objs);
SCM scm_null_p (SCM x);
SCM scm_list_p (SCM x);
long scm_ilength (SCM sx);
SCM scm_length (SCM x);
SCM scm_append (SCM args);
SCM scm_append_x (SCM args);
SCM scm_reverse (SCM lst);
SCM scm_reverse_x (SCM lst, SCM newtail);
SCM scm_list_ref (SCM lst, SCM k);
SCM scm_list_set_x (SCM lst, SCM k, SCM val);
SCM scm_list_cdr_set_x (SCM lst, SCM k, SCM val);
SCM scm_last_pair (SCM sx);
SCM scm_list_tail (SCM lst, SCM k);
SCM scm_c_memq (SCM x, SCM lst);
SCM scm_memq (SCM x, SCM lst);
SCM scm_memv (SCM x, SCM lst);
SCM scm_member (SCM x, SCM lst);
SCM scm_delq_x (SCM item, SCM lst);
SCM scm_delv_x (SCM item, SCM lst);
SCM scm_delete_x (SCM item, SCM lst, SCM pred);
SCM scm_list_copy (SCM lst);
SCM scm_delq (SCM item, SCM lst);
SCM scm_delv (SCM item, SCM lst);
SCM scm_delete (SCM item, SCM lst, SCM pred);
SCM scm_delq1_x (SCM item, SCM lst);
SCM scm_delv1_x (SCM item, SCM lst);
SCM scm_delete1_x (SCM item, SCM lst);
SCM scm_filter (SCM pred, SCM list);
SCM scm_filter_x (SCM pred, SCM list);



/* internal functions */

SCM scm_i_finite_list_copy (SCM /* a list known to be finite */);
void scm_init_list (void);

#endif  /* SCM_LIST_H */
