/* classes: h_files */

#ifndef SCM_MACROS_H
#define SCM_MACROS_H
#include "include/__scm.h"


#define SCM_ASSYNT(_cond, _msg, _subr) \
  if (!(_cond)) scm_misc_error (_subr, _msg, SCM_EOL);

// NFS: cfr eval implicit apply branch dispatch 4a & 5
#define SCM_MACROP(X) (!SCM_IMP (X) && SCM_CELL_TYPE(X) == scm_tc16_macro)

// #define SCM_MACROP(x) SCM_SMOB_PREDICATE (scm_tc16_macro, (x))
#define SCM_MACRO_TYPE(m) SCM_SMOB_FLAGS (m)
#define SCM_BUILTIN_MACRO_P(x) (SCM_MACROP (x) && SCM_MACRO_TYPE (x) == 3)
#define SCM_MACRO_CODE(m) SCM_SMOB_OBJECT (m)

scm_t_tag scm_tc16_macro;

SCM scm_i_makbimacro (SCM code);
SCM scm_makmmacro (SCM code);
SCM scm_makacro (SCM code);
SCM scm_macro_p (SCM obj);
SCM scm_macro_type (SCM m);
SCM scm_macro_name (SCM m);
SCM scm_macro_transformer (SCM m);
SCM scm_make_synt (const char *name,
			   SCM (*macroizer) (SCM),
			   SCM (*fcn) ());
void scm_init_macros (void);
void x_inclusion_macros (void);

#if SCM_ENABLE_DEPRECATED == 1
SCM scm_makmacro (SCM code);
#endif

#endif  /* SCM_MACROS_H */
