/* classes: h_files */

#ifndef SCM_READ_H
#define SCM_READ_H
#include "include/__scm.h"


/* SCM_LINE_INCREMENTORS are the characters which cause the line count to
 * be incremented for the purposes of error reporting.  This feature
 * is only used for scheme code loaded from files.
 *
 * SCM_WHITE_SPACES are other characters which should be treated like spaces
 * in programs.
 */

#define SCM_LINE_INCREMENTORS  SCM_MAKE_CHAR('\n')
#define PCM_LINE_INCREMENTORS  '\n'

#define SCM_SINGLE_SPACES  SCM_MAKE_CHAR(' '):case SCM_MAKE_CHAR('\r'):case SCM_MAKE_CHAR('\f')
#define PCM_SINGLE_SPACES  ' ':case '\r':case '\f'

#define SCM_WHITE_SPACES  SCM_SINGLE_SPACES: case SCM_MAKE_CHAR('\t')
#define PCM_WHITE_SPACES  PCM_SINGLE_SPACES: case '\t'


SCM scm_sym_dot;

SCM scm_read (SCM port);
size_t scm_read_token (int ic, SCM * tok_buf, SCM port, int weird);

void scm_i_input_error (const char *func, SCM port,
				const char *message, SCM arg)
  SCM_NORETURN;

void scm_init_read (void);
void x_inclusion_read (void);

#endif  /* SCM_READ_H */
