/* classes: h_files */

#ifndef SCM_SOCKET_H
#define SCM_SOCKET_H
#include "include/__scm.h"



SCM scm_inet_aton (SCM address);
SCM scm_inet_ntoa (SCM inetid);
SCM scm_inet_netof (SCM address);
// deprecated SCM scm_lnaof (SCM address);
SCM scm_inet_makeaddr (SCM net, SCM lna);
SCM scm_inet_pton (SCM family, SCM address);
SCM scm_inet_ntop (SCM family, SCM address);
SCM scm_socket (SCM family, SCM style, SCM proto);
SCM scm_socketpair (SCM family, SCM style, SCM proto);
SCM scm_getsockopt (SCM sfd, SCM level, SCM optname);
SCM scm_setsockopt (SCM sfd, SCM level, SCM optname, SCM value);
SCM scm_shutdown (SCM sfd, SCM how);
SCM scm_connect (SCM sockfd, SCM fam, SCM address, SCM args);
SCM scm_bind (SCM sockfd, SCM fam, SCM address, SCM args);
SCM scm_listen (SCM sfd, SCM backlog);
SCM scm_accept (SCM sockfd);
SCM scm_getsockname (SCM sockfd);
SCM scm_getpeername (SCM sockfd);
SCM scm_recv (SCM sockfd, SCM buff_or_size, SCM flags);
SCM scm_send (SCM sockfd, SCM message, SCM flags);
SCM scm_recvfrom (SCM sockfd, SCM buff_or_size, SCM flags);
SCM scm_sendto (SCM sockfd, SCM message, SCM fam, SCM address, SCM args_and_flags);
void scm_init_socket (void);

/* Wrapping/unwrapping address objects.  */
struct sockaddr;
SCM scm_from_sockaddr (const struct sockaddr *address,
			       unsigned addr_size);
struct sockaddr *scm_to_sockaddr (SCM address, size_t *adress_size);
struct sockaddr *scm_c_make_socket_address (SCM family, SCM address,
						    SCM args,
						    size_t *address_size);
SCM scm_make_socket_address (SCM family, SCM address, SCM args);

#endif  /* SCM_SOCKET_H */
