/* classes: h_files */

#ifndef SCM_STIME_H
#define SCM_STIME_H
#include "include/__scm.h"

#include <unistd.h>  /* for sysconf */



/* This should be figured out by autoconf.

   sysconf(_SC_CLK_TCK) is best, since it's the actual running kernel, not
   some compile-time CLK_TCK.  On glibc 2.3.2 CLK_TCK (when defined) is in
   fact sysconf(_SC_CLK_TCK) anyway.

   CLK_TCK is obsolete in POSIX.  In glibc 2.3.2 it's defined by default,
   but if you define _GNU_SOURCE or _POSIX_C_SOURCE to get other features
   then it goes away.  */

#if ! defined(SCM_TIME_UNITS_PER_SECOND) && defined(_SC_CLK_TCK)
#  define SCM_TIME_UNITS_PER_SECOND ((int) sysconf (_SC_CLK_TCK))
#endif
#if ! defined(SCM_TIME_UNITS_PER_SECOND) && defined(CLK_TCK)
#  define SCM_TIME_UNITS_PER_SECOND ((int) CLK_TCK)
#endif
#if ! defined(SCM_TIME_UNITS_PER_SECOND) && defined(CLOCKS_PER_SEC)
#  define SCM_TIME_UNITS_PER_SECOND ((int) CLOCKS_PER_SEC)
#endif
#if ! defined(SCM_TIME_UNITS_PER_SECOND)
#  define SCM_TIME_UNITS_PER_SECOND 60
#endif


long scm_c_get_internal_run_time (void);
SCM scm_get_internal_real_time (void);
SCM scm_get_internal_run_time (void);
SCM scm_current_time (void);
SCM scm_gettimeofday (void);
SCM scm_localtime (SCM time, SCM zone);
SCM scm_gmtime (SCM time);
SCM scm_mktime (SCM sbd_time, SCM zone);
SCM scm_tzset (void);
SCM scm_times (void);
SCM scm_strftime (SCM format, SCM stime);
SCM scm_strptime (SCM format, SCM string);
void scm_init_stime (void);
void x_inclusion_stime (void);

#endif  /* SCM_STIME_H */
