/* classes: h_files */

#ifndef SCM_VECTORS_H
#define SCM_VECTORS_H
#include "include/__scm.h"


SCM scm_vector_p (SCM x);
SCM scm_vector_length (SCM v);
SCM scm_vector (SCM l);
SCM scm_vector_ref (SCM v, SCM k);
SCM scm_vector_set_x (SCM v, SCM k, SCM obj);
SCM scm_make_vector (SCM k, SCM fill);
SCM scm_vector_to_list (SCM v);
SCM scm_vector_fill_x (SCM v, SCM fill_x);
SCM scm_vector_move_left_x (SCM vec1, SCM start1, SCM end1,
				    SCM vec2, SCM start2);
SCM scm_vector_move_right_x (SCM vec1, SCM start1, SCM end1, 
				     SCM vec2, SCM start2);
SCM scm_vector_copy (SCM vec);

int scm_is_vector (SCM obj);
int scm_is_simple_vector (SCM obj);
SCM scm_c_make_vector (size_t len, SCM fill);
size_t scm_c_vector_length (SCM vec);

const SCM *scm_vector_elements (SCM vec, size_t *lenp, ssize_t *incp);
SCM *scm_vector_writable_elements (SCM vec, size_t *lenp, ssize_t *incp);

/* !!! Internals */

#define SCM_VECTOR_P(x)        (!SCM_IMP(x) && (SCM_TYP7(x)==scm_tc7_vector))
#define SCM_I_IS_VECTOR        SCM_VECTOR_P
#define SCM_I_VECTOR_LENGTH(x) ((size_t) SCM_CELL_WORD_0 (x))
#define SCM_I_VECTOR_ELTS(x)   (SCM_CELL_OBJECT_LOC (x, 1))
#define SCM_I_VECTOR_WELTS(x)  (SCM_I_VECTOR_ELTS(x))

/* Fast, non-checking accessors for simple vectors.
 */
SCM  scm_i_vector_ref   (SCM vector, unsigned long index);
void scm_i_vector_set_x (SCM vector, unsigned long index, SCM element);
#define SCM_SIMPLE_VECTOR_LENGTH(x)      SCM_I_VECTOR_LENGTH(x)
#define SCM_SIMPLE_VECTOR_REF  scm_i_vector_ref
#define SCM_SIMPLE_VECTOR_SET  scm_i_vector_set_x
#define TMP_SIMPLE_VECTOR_REF(v,i)  ((SCM_I_VECTOR_WELTS(v))[i])


void scm_i_vector_free (SCM vec);
SCM  scm_i_vector_equal_p (SCM x, SCM y);

void scm_init_vectors (void);
void x_inclusion_vectors (void);

#endif  /* SCM_VECTORS_H */
