// Strange things happend in main. Some books still talk about
// these but while pulling out this file out of one of those
// weather turned bad and the fog ... what's that?
// No one left to find the missing page of that book again, right?
// Welcome to the death side of wonderland full of dinosaurs,
// hobbits and other interesting combinations of letters.

#include "include/config.h"
#include "include/ihub.h"
#include "include/scmconfig.h"
#include "include/libpath.h"
#include <unistd.h>
#include <locale.h>

/*
 * ??? Should I write some comment here?
 */
unsigned int global_debug_interpreter = 1;

/*
 * Interpreter Main: Program Entry Point
 */

/* static void /\* XXX unused *\/ */
/* inner_main (void *closure SCM_UNUSED, int argc, char **argv) */
/* { */
/*   if (global_debug_interpreter) */
/*     fprintf (stderr, "VSI initialization trace:" */
/*              " interpreter-main.c: inner_main\n"); */

/*   scm_shell (argc, argv); */
/* } */

/* It's not even a baby dinosaur but ... */
static int
c_debug_p (int argc, char **argv)
{
  const char flag[] = "--debug";
  size_t argument_index  = 0;
  size_t offset = 0;

  for (argument_index = 0, offset = 0;
       argument_index < argc;
       argument_index++, offset = 0)
  {
    while (flag[offset] == argv[argument_index][offset]) {
      if (argv[argument_index][offset] == '\0')
        return 1;
      offset++;
    }
    /* Two minus signs mean stop scanning arguments as
    options. Everything after the double minus sign should not be
    considered an option but a file name to load. */
    if (offset == 2 && argv[argument_index][offset] == '\0')
      return 0;
  }
  return 0;
}

/* GC->TRIM Compatibility */
void *global_stack_base;
#include <sys/resource.h>  // rlimit
int
main (int argc, char **argv)
{
  global_stack_base = argv;
  SCM switches = SCM_EOL;
  global_debug_interpreter = c_debug_p (argc, argv);

  { // XXX patch (brass preliminaries)
    // Locale: What we tried to do here is to receive UTF-8 sequences
    //         from the terminal instead of its unspecified behavior.
    //         This one didn't really work.
    //         Maybe termios has some switch somewhere, too.
    // FWIW: VSI is supposed to remain in the C locale
    char *locale = setlocale (LC_ALL, "C");
    if (global_debug_interpreter) {
      if (locale)
        fprintf (stderr, "VSI: (main.c) Locale: %s\n", locale);
      else
        fprintf (stderr, "VSI: (main.c) setlocale error");
    }
  }

 
  // XXX TODO the following is posix rlimit and should be exported to Scheme
  { // XXX more stack, but little heap for debugging
    // (Why is swapping still slower than restarting the computer?)
    struct rlimit my_limit;
    int lim = 0;

    lim |= getrlimit (RLIMIT_STACK, &my_limit);
    my_limit.rlim_cur = 800000000; // 800MB
    // my_limit.rlim_cur = 8000000; // 8MB
    if (lim == 0) lim |= setrlimit (RLIMIT_STACK, &my_limit);
    if (global_debug_interpreter) {
      if (lim != 0) {
        fprintf (stderr, "VSI: problem while setting a limit on stack space\n");
      } else {
        fprintf (stderr, "VSI: stack space limit in effect\n");
      }
    }

    lim = 0;
    lim |= getrlimit (RLIMIT_AS, &my_limit);
    my_limit.rlim_cur = 1000000000; // 1GB
    if (lim == 0) lim |= setrlimit (RLIMIT_AS, &my_limit);
    if (global_debug_interpreter) {
      if (lim != 0) {
        fprintf (stderr, "VSI: problem while setting a limit on address space\n");
      } else {
        fprintf (stderr, "VSI: address space limit in effect\n");
      }
    }
  }


  if (global_debug_interpreter) {
    debug_print_system_info (argv);
    fprintf (stderr, "VSI initialization trace: interpreter-main.c: main\n");
  }

  /* No SCM here. */
  scm_init_interpreter ();
  /* Now we can SCM. */

  /* SCM tst_br = c_string_to_symbol ("TST"); */
  /* scm_display (tst_br, scm_current_output_port ()); */
  /* scm_newline (scm_current_output_port ()); */
  /* exit (0); */


  if (global_debug_interpreter) {
    debug_print_smob_info ();
  }

  // Deliver the debug switch position to the core.
  scm_c_define ("sys-debug-interpreter",
                scm_from_bool (global_debug_interpreter));

  switches = scm_compile_shell_switches (argc, argv);
  reference_parameter (switches);

  if (global_debug_interpreter) {
    fprintf (stderr, "Compiled Shell Switches: ");
    scm_display (switches, scm_current_error_port ());
    scm_newline (scm_current_error_port ());
  }
  scm_c_define ("%session-arguments", switches);
  dereference_parameter (switches);
  
  /* Meta Switches and Script Reading? */
  /* int status = scm_exit_status (scm_eval_x (switches, */
  /*                                           scm_current_module ())); */
  /* if (status) */
  /*   exit (status); */

  scm_load_startup_files ();
  
  exit (0);
}
