#include "include/config.h"

#include "include/_scm.h"

#include "include/validate.h"
#include "include/boolean.h"
#include "include/tags.h"




SCM_DEFINE (scm_not, "not", 1, 0, 0, 
            (SCM x),
            "Return @code{#t} iff @var{x} is @code{#f}, else return @code{#f}.")
#define FUNC_NAME s_scm_not
{
  reference_parameter (x);
  SCM answer = scm_from_bool (scm_is_false (x));
  dereference_parameter (x);
  return (answer);
}
#undef FUNC_NAME


SCM_DEFINE (scm_boolean_p, "boolean?", 1, 0, 0, 
           (SCM obj),
            "Return @code{#t} iff @var{obj} is either @code{#t} or @code{#f}.")
#define FUNC_NAME s_scm_boolean_p
{
  reference_parameter (obj);
  SCM answer = scm_from_bool (scm_is_bool (obj));
  dereference_parameter (obj);
  return (answer);
}
#undef FUNC_NAME

int
scm_is_bool (SCM x)
{
  return scm_is_eq (x, SCM_BOOL_F) || scm_is_eq (x, SCM_BOOL_T);
}

int
scm_to_bool (SCM x)
{
  if (scm_is_eq (x, SCM_BOOL_F))
    return 0;
  else if (scm_is_eq (x, SCM_BOOL_T))
    return 1;
  else    
    scm_wrong_type_arg (NULL, 0, x);
}

inline int
sharp_scm_is_false (SCM object)
{
  int result = (scm_is_false (object));
  dereference_return_value (object);
  return (result);
}

void
scm_init_boolean ()
{
#include "include/boolean.x"
}
