#include "include/config.h"

#include "include/_scm.h"
#include "include/validate.h"
#include "include/brass.h"
#include "include/vectors.h"
#include "include/pairs.h"

#include "include/convert.h"

#ifdef HAVE_STRING_H
#include <string.h>
#endif

/* char *scm_c_scm2chars (SCM obj, char *dst);
   SCM   scm_c_chars2scm (const char *src, long n);
   SCM   scm_c_chars2byvect (const char *src, long n);
*/

#define CTYPE            char
#define FROM_CTYPE       scm_from_char
#define SCM2CTYPES       scm_c_scm2chars
#define CTYPES2SCM       scm_c_chars2scm
#include "include/convert.i.c"

/* short *scm_c_scm2shorts (SCM obj, short *dst);
   SCM scm_c_shorts2scm (const short *src, long n);
   SCM scm_c_shorts2svect (const short *src, long n);
*/

#define CTYPE            short
#define FROM_CTYPE       scm_from_short
#define SCM2CTYPES       scm_c_scm2shorts
#define CTYPES2SCM       scm_c_shorts2scm
#include "include/convert.i.c"

/* int *scm_c_scm2ints (SCM obj, int *dst);
   SCM scm_c_ints2scm (const int *src, long n);
   SCM scm_c_ints2ivect (const int *src, long n);
   SCM scm_c_uints2uvect (const unsigned int *src, long n);
*/

#define CTYPE            int
#define FROM_CTYPE       scm_from_int
#define SCM2CTYPES       scm_c_scm2ints
#define CTYPES2SCM       scm_c_ints2scm
#define CTYPE_2          unsigned int

#include "include/convert.i.c"

/* long *scm_c_scm2longs (SCM obj, long *dst);
   SCM scm_c_longs2scm (const long *src, long n);
   SCM scm_c_longs2ivect (const long *src, long n);
   SCM scm_c_ulongs2uvect (const unsigned long *src, long n);
*/

#define CTYPE            long
#define FROM_CTYPE       scm_from_long
#define SCM2CTYPES       scm_c_scm2longs
#define CTYPES2SCM       scm_c_longs2scm
#define CTYPE_2          unsigned int

#include "include/convert.i.c"

/* float *scm_c_scm2floats (SCM obj, float *dst);
   SCM scm_c_floats2scm (const float *src, long n);
   SCM scm_c_floats2fvect (const float *src, long n);
*/

#define CTYPE            float
#define FROM_CTYPE       scm_from_double
#define SCM2CTYPES       scm_c_scm2floats
#define CTYPES2SCM       scm_c_floats2scm
#include "include/convert.i.c"

/* double *scm_c_scm2doubles (SCM obj, double *dst);
   SCM scm_c_doubles2scm (const double *src, long n);
   SCM scm_c_doubles2dvect (const double *src, long n);
*/

#define CTYPE            double
#define FROM_CTYPE       scm_from_double
#define SCM2CTYPES       scm_c_scm2doubles
#define CTYPES2SCM       scm_c_doubles2scm
#include "include/convert.i.c"
