#include "include/config.h"

#include "include/_scm.h"
#include "include/brass.h"
#include "include/nature.h"

#include "include/validate.h"
#include "include/symbols.h"

/*
 * Symbol Statistics
 */
unsigned long global_number_of_symbols_created = 0;


/* Symbol Data Type Implementation
 * see also interpreter-nature.c
 */

SCM_DEFINE (scm_symbol_p, "symbol?", 1, 0, 0, 
	    (SCM obj),
	    "Return @code{#t} if @var{obj} is a symbol, otherwise return\n"
	    "@code{#f}.")
#define FUNC_NAME s_scm_symbol_p
{
  reference_parameter (obj);
  SCM answer = scm_from_bool (scm_is_symbol (obj));
  dereference_parameter (obj);
  return (answer);
}
#undef FUNC_NAME

SCM_DEFINE (scm_symbol_to_brass, "symbol->brass", 1, 0, 0, (SCM s), "")
#define FUNC_NAME s_scm_symbol_to_brass
{
  reference_parameter (s);
  SCM_VALIDATE_SYMBOL (1, s);
  SCM answer = scm_i_copy_brass (s);
  reference_count_return (answer);
  dereference_parameter (s);
  return (answer);
}
#undef FUNC_NAME


SCM_DEFINE (scm_brass_to_symbol, "brass->symbol", 1, 0, 0, (SCM br), "")
#define FUNC_NAME s_scm_brass_to_symbol
{
  reference_parameter (br);
  SCM_VALIDATE_BRASS (1, br);

  SCM answer = SCM_BOOL_F;
  if (BR_LENGTH (br) > 0) {
    answer = scm_i_brass_to_symbol (br);
  }

  reference_count_return (answer);
  dereference_parameter (br);
  return (answer);
}
#undef FUNC_NAME


void
x_inclusion_symbols ()
{
#include "include/symbols.x"
}
