(define io-select select) ; TODO push this into VSI-C


(define sys-send-bytes:incomplete-writes 0)
(define (send-bytes channel bytes)
 (let ((s (write-bytes bytes channel))) ;; TODO change argument order of wb
  (cond
  ((not s) (error "send-bytes did it: write-bytes returned falsity"))
  ((= s (byte-string-length bytes))
     (when (port? channel) (force-output channel))
     #t)
  ((< s (byte-string-length bytes))
     (set! sys-send-bytes:incomplete-writes
           (+ sys-send-bytes:incomplete-writes 1))
     (io-select '() (list channel) '()) ; ??? We shouldn't see any interrupts with the current signal handling (VOS/vop.scm)?
     (send-bytes channel
                 (byte-string-select bytes
                   s (- (byte-string-length bytes) s))))
  ((> s (byte-string-length bytes))
     (error "send-bytes had it: wrote too much"))
)))


(define OPEN_READ "r")
(define OPEN_WRITE "w")
(define OPEN_BOTH "r+")

(define *null-device* "/dev/null")

(define (open-input-file str)
  (open-file str OPEN_READ))

(define (open-output-file str)
  (open-file str OPEN_WRITE))

(define (open-io-file str) 
  (open-file str OPEN_BOTH))

(define close-io-port close-port)


(define (call-with-input-file str proc)
  (let* ((file (open-input-file str))
	 (ans (dynamic-wind (lambda () #t)
                            (lambda () (proc file))
                            (lambda () (close-port file)))))
    ans))

(define (call-with-output-file str proc)
  (let* ((file (open-output-file str))
	 (ans (dynamic-wind (lambda () #t)
                            (lambda () (proc file))
                            (lambda () (close-port file)))))
    ans))

(define (with-input-from-port port thunk)
  (let* ((swaports (lambda () (set! port (set-current-input-port port)))))
    (dynamic-wind swaports thunk swaports)))

(define (with-output-to-port port thunk)
  (let* ((swaports (lambda () (set! port (set-current-output-port port)))))
    (dynamic-wind swaports thunk swaports)))

(define (with-error-to-port port thunk)
  (let* ((swaports (lambda () (set! port (set-current-error-port port)))))
    (dynamic-wind swaports thunk swaports)))


(define (with-input-from-file file thunk)
  (let* ((nport (open-input-file file))
	 (ans (dynamic-wind (lambda () #t)
                            (lambda () (with-input-from-port nport thunk))
                            (lambda () (close-port nport)))))
    ans))

(define (with-output-to-file file thunk)
  (let* ((nport (open-output-file file))
	 (ans (dynamic-wind (lambda () #t)
                            (lambda () (with-output-to-port nport thunk))
                            (lambda () (close-port nport)))))
    ans))

(define (with-error-to-file file thunk)
  (let* ((nport (open-output-file file))
	 (ans (dynamic-wind (lambda () #t)
                            (lambda () (with-error-to-port nport thunk))
                            (lambda () (close-port nport)))))
    ans))


(define (with-input-from-string string thunk)
  (call-with-input-string string
   (lambda (p) (with-input-from-port p thunk))))

(define (with-output-to-string thunk)
  (call-with-output-string
   (lambda (p) (with-output-to-port p thunk))))

(define (with-error-to-string thunk)
  (call-with-output-string
   (lambda (p) (with-error-to-port p thunk))))

