;;
;; Experimental POSIX inclusion
;;
;; XXX this is a compile time file
;; manage this before it's the dump of all ...

;;
;; bits/termios.h

;; typedef unsigned char	cc_t;
;; typedef unsigned int	speed_t;
;; typedef unsigned int	tcflag_t;

(define NCCS 32)
;; struct termios
;;   {
;;     tcflag_t c_iflag;		/* input mode flags */
;;     tcflag_t c_oflag;		/* output mode flags */
;;     tcflag_t c_cflag;		/* control mode flags */
;;     tcflag_t c_lflag;		/* local mode flags */
;;     cc_t c_line;			/* line discipline */
;;     cc_t c_cc[NCCS];	         /* control characters */
;;     speed_t c_ispeed;		/* input speed */
;;     speed_t c_ospeed;		/* output speed */
;; (define _HAVE_STRUCT_TERMIOS_C_ISPEED 1
;; (define _HAVE_STRUCT_TERMIOS_C_OSPEED 1
;;   };

;; c_cc characters | these serve as indices into the cc array and are numbers
(define VINTR   0)
(define VQUIT   1)
(define VERASE  2)
(define VKILL   3)
(define VEOF    4)
(define VTIME   5)
(define VMIN    6)
(define VSWTC   7)
(define VSTART  8)
(define VSTOP   9)
(define VSUSP  10)
(define VEOL   11)
(define VREPRINT 12)
(define VDISCARD 13)
(define VWERASE 14)
(define VLNEXT 15)
(define VEOL2 16)

(define (screw-constant constant)
 (if (number? constant)
   (number->byte-string constant 4)
   constant)) ; opimistic

(define pc screw-constant)

;; /* c_iflag bits */
(define IGNBRK	(pc #o0000001))
(define BRKINT	(pc #o0000002))
(define IGNPAR	(pc #o0000004))
(define PARMRK	(pc #o0000010))
(define INPCK	(pc #o0000020))
(define ISTRIP	(pc #o0000040))
(define INLCR	(pc #o0000100))
(define IGNCR	(pc #o0000200))
(define ICRNL	(pc #o0000400))
(define IUCLC	(pc #o0001000))
(define IXON	(pc #o0002000))
(define IXANY	(pc #o0004000))
(define IXOFF	(pc #o0010000))
(define IMAXBEL	(pc #o0020000))
(define IUTF8	(pc #o0040000))

;; /* c_oflag bits */
(define OPOST	(pc #o0000001))
(define OLCUC	(pc #o0000002))
(define ONLCR	(pc #o0000004))
(define OCRNL	(pc #o0000010))
(define ONOCR	(pc #o0000020))
(define ONLRET	(pc #o0000040))
(define OFILL	(pc #o0000100))
(define OFDEL	(pc #o0000200))

( define NLDLY	(pc #o0000400))
( define   NL0	(pc #o0000000))
( define   NL1	(pc #o0000400))
( define CRDLY	(pc #o0003000))
( define   CR0	(pc #o0000000))
( define   CR1	(pc #o0001000))
( define   CR2	(pc #o0002000))
( define   CR3	(pc #o0003000))
( define TABDLY	(pc #o0014000))
( define   TAB0	(pc #o0000000))
( define   TAB1	(pc #o0004000))
( define   TAB2	(pc #o0010000))
( define   TAB3	(pc #o0014000))
( define BSDLY	(pc #o0020000))
( define   BS0	(pc #o0000000))
( define   BS1	(pc #o0020000))
( define FFDLY	(pc #o0100000))
( define   FF0	(pc #o0000000))
( define   FF1	(pc #o0100000))

(define VTDLY	(pc #o0040000))
(define   VT0	(pc #o0000000))
(define   VT1	(pc #o0040000))

(define XTABS	(pc #o0014000))

;; /* c_cflag bit meaning */
(define CBAUD	(pc #o0010017))

(define  B0	(pc #o0000000)) ;	/* hang up */
(define  B50	(pc #o0000001))
(define  B75	(pc #o0000002))
(define  B110	(pc #o0000003))
(define  B134	(pc #o0000004))
(define  B150	(pc #o0000005))
(define  B200	(pc #o0000006))
(define  B300	(pc #o0000007))
(define  B600	(pc #o0000010))
(define  B1200	(pc #o0000011))
(define  B1800	(pc #o0000012))
(define  B2400	(pc #o0000013))
(define  B4800	(pc #o0000014))
(define  B9600	(pc #o0000015))
(define  B19200	(pc #o0000016))
(define  B38400	(pc #o0000017))

(define EXTA B19200)
(define EXTB B38400)

(define CSIZE	(pc #o0000060))
(define   CS5	(pc #o0000000))
(define   CS6	(pc #o0000020))
(define   CS7	(pc #o0000040))
(define   CS8	(pc #o0000060))
(define CSTOPB	(pc #o0000100))
(define CREAD	(pc #o0000200))
(define PARENB	(pc #o0000400))
(define PARODD	(pc #o0001000))
(define HUPCL	(pc #o0002000))
(define CLOCAL	(pc #o0004000))

(define CBAUDEX (pc #o0010000))

(define  B57600   (pc #o0010001))
(define  B115200  (pc #o0010002))
(define  B230400  (pc #o0010003))
(define  B460800  (pc #o0010004))
(define  B500000  (pc #o0010005))
(define  B576000  (pc #o0010006))
(define  B921600  (pc #o0010007))
(define  B1000000 (pc #o0010010))
(define  B1152000 (pc #o0010011))
(define  B1500000 (pc #o0010012))
(define  B2000000 (pc #o0010013))
(define  B2500000 (pc #o0010014))
(define  B3000000 (pc #o0010015))
(define  B3500000 (pc #o0010016))
(define  B4000000 (pc #o0010017))
(define __MAX_BAUD B4000000)
(define CIBAUD	  (pc #o002003600000)) ;	/* input baud rate (not used) */
(define CMSPAR   (pc #o010000000000)) ;	/* mark or space (stick) parity */
(define CRTSCTS  (pc #o020000000000)) ;	/* flow control */

;; /* c_lflag bits */
(define ISIG	(pc #o0000001))
(define ICANON	(pc #o0000002))
(define XCASE	(pc #o0000004))
(define ECHO	(pc #o0000010))
(define ECHOE	(pc #o0000020))
(define ECHOK	(pc #o0000040))
(define ECHONL	(pc #o0000100))
(define NOFLSH	(pc #o0000200))
(define TOSTOP	(pc #o0000400))

(define ECHOCTL (pc #o0001000))
(define ECHOPRT (pc #o0002000))
(define ECHOKE	 (pc #o0004000))
(define FLUSHO	 (pc #o0010000))
(define PENDIN	 (pc #o0040000))

(define IEXTEN	(pc #o0100000))

(define EXTPROC (pc #o0200000))


;; /* tcflow() and TCXONC use these */
(define	TCOOFF		(pc 0))
(define	TCOON		(pc 1))
(define	TCIOFF		(pc 2))
(define	TCION		(pc 3))

;; /* tcflush() and TCFLSH use these */
(define	TCIFLUSH	(pc 0))
(define	TCOFLUSH	(pc 1))
(define	TCIOFLUSH	(pc 2))

;; /* tcsetattr uses these */
(define	TCSANOW		(pc 0))
(define	TCSADRAIN	(pc 1))
(define	TCSAFLUSH	(pc 2))


;;
;; inotify (that's not even posix)
;; 

(define (screw-constant constant)
  (number->byte-string constant 4))
(define pc screw-constant)

(define IN_CLOEXEC  (pc 02000000))
(define IN_NONBLOCK (pc 00004000))


;; (see also Examples/control.scm)
;; /* Structure describing an inotify event.  */
;; struct inotify_event
;; {
;;   int wd;		/* Watch descriptor.  */
;;   uint32_t mask;	/* Watch mask.  */
;;   uint32_t cookie;	/* Cookie to synchronize two events.  */
;;   uint32_t len;		/* Length (including NULs) of name.  */
;;   char name __flexarr;	/* Name.  */
;; };


;;  Supported events suitable for MASK parameter of INOTIFY_ADD_WATCH.  
(define IN_ACCESS	 (pc #x00000001)) ;  File was accessed.  
(define IN_MODIFY	 (pc #x00000002)) ;  File was modified.  
(define IN_ATTRIB	 (pc #x00000004)) ;  Metadata changed.  
(define IN_CLOSE_WRITE	 (pc #x00000008)) ;  Writtable file was closed.  
(define IN_CLOSE_NOWRITE (pc #x00000010)) ;  Unwrittable file closed.  
(define IN_CLOSE	 (bit-or IN_CLOSE_WRITE IN_CLOSE_NOWRITE)) ; Close. 
(define IN_OPEN		 (pc #x00000020)) ;  File was opened.  
(define IN_MOVED_FROM	 (pc #x00000040)) ;  File was moved from X.  
(define IN_MOVED_TO      (pc #x00000080)) ;  File was moved to Y.  
(define IN_MOVE		 (bit-or IN_MOVED_FROM IN_MOVED_TO))  ; Moves.  
(define IN_CREATE	 (pc #x00000100)) ;  Subfile was created.  
(define IN_DELETE	 (pc #x00000200)) ;  Subfile was deleted.  
(define IN_DELETE_SELF	 (pc #x00000400)) ;  Self was deleted.  
(define IN_MOVE_SELF	 (pc #x00000800)) ;  Self was moved.  

;;  Events sent by the kernel.  
(define IN_UNMOUNT	 (pc #x00002000)) ;  Backing fs was unmounted.  
(define IN_Q_OVERFLOW	 (pc #x00004000)) ;  Event queued overflowed.  
(define IN_IGNORED	 (pc #x00008000)) ;  File was ignored.  

;;  Helper events.  
(define IN_CLOSE	 (bit-or IN_CLOSE_WRITE IN_CLOSE_NOWRITE)) ; Close.
(define IN_MOVE		 (bit-or IN_MOVED_FROM IN_MOVED_TO))       ; Moves.

;;  Special flags.  
(define IN_ONLYDIR	 (pc #x01000000)) ;  Only watch the path if it is a
					  ;  directory.  
(define IN_DONT_FOLLOW	 (pc #x02000000)) ;  Do not follow a sym link.  
(define IN_EXCL_UNLINK	 (pc #x04000000)) ;  Exclude events on unlinked
					  ;  objects.  
(define IN_MASK_ADD	 (pc #x20000000)) ;  Add to the mask of an already
					  ;  existing watch.  
(define IN_ISDIR	 (pc #x40000000)) ;  Event occurred against dir.  
(define IN_ONESHOT	 (pc #x80000000)) ;  Only send event once.  

;;  All events which a program can wait on.  
(define IN_ALL_EVENTS
 (bit-or IN_ACCESS  IN_MODIFY  IN_ATTRIB  IN_CLOSE_WRITE
         IN_CLOSE_NOWRITE  IN_OPEN  IN_MOVED_FROM
         IN_MOVED_TO  IN_CREATE  IN_DELETE
         IN_DELETE_SELF  IN_MOVE_SELF))

(display "PC mark 1")  (newline)

;;
;; File System Access Flags (sys/stat.h) | stat(2)

(define (screw-constant constant)
  (number->byte-string constant 4))
(define pc screw-constant)

(display "PC mark 2") (newline)

;; Special Permissions
(define S_ISUID (pc #o4000)) ;  set-user-ID bit
(define S_ISGID (pc #o2000)) ;  set-group-ID bit
(define S_ISVTX (pc #o1000)) ;  sticky bit

;; Regular Permissions (These can be considered numerical constant.)
(define S_IRWXU (pc #o700))  ;  mask for file owner permissions
(define S_IRUSR (pc #o400))  ;  read permission
(define S_IWUSR (pc #o200))  ;  write permission
(define S_IXUSR (pc #o100))  ;  execute permission

(define S_IRWXG (pc #o070))  ;  mask for group permissions
(define S_IRGRP (bit-shift-right S_IRUSR 3))
(define S_IWGRP (bit-shift-right S_IWUSR 3))
(define S_IXGRP (bit-shift-right S_IXUSR 3))

(define S_IRWXO (pc #o007))  ;  mask for permissions for others (not in group)
(define S_IROTH (bit-shift-right S_IRGRP 3))
(define S_IWOTH (bit-shift-right S_IWGRP 3))
(define S_IXOTH (bit-shift-right S_IXGRP 3))

;; Regular Permission Mask
(define SCA_IRWXA (bit-or S_IRWXO S_IRWXG S_IRWXU))

(display "PC mark 3") (newline)
;; File Type Flags
(define S_IFMT     (pc #o170000)) ;   bit mask for the file type bit fields

(define S_IFSOCK   (pc #o140000)) ;   socket
(define S_IFLNK    (pc #o120000)) ;   symbolic link
(define S_IFREG    (pc #o100000)) ;   regular file
(define S_IFBLK    (pc #o060000)) ;   block device
(define S_IFDIR    (pc #o040000)) ;   directory
(define S_IFCHR    (pc #o020000)) ;   character device
(define S_IFIFO    (pc #o010000)) ;   FIFO

(display "PC mark 4") (newline)

;;
;; File Open Flags
;; XXX Transitional Setup: import constants directly

(define (screw-constant constant)
 (if (number? constant)
   (number->byte-string constant 4)
   constant)) ; opimistic

(define pc screw-constant)

(define O_RDONLY    (pc O_RDONLY))
(define O_WRONLY    (pc O_WRONLY))
(define O_RDWR      (pc O_RDWR))
(define O_APPEND    (pc O_APPEND))
;(define O_ASYNC     (pc O_ASYNC))
;(define O_CLOEXEC   (pc O_CLOEXEC))
(define O_CREAT     (pc O_CREAT))
;(define O_DIRECT    (pc O_DIRECT))
;(define O_DIRECTORY (pc O_DIRECTORY))
;(define O_DSYNC     (pc O_SYNC))
;(define O_EXCL      (pc O_EXCL))
;(define O_LARGEFILE (pc O_LARGEFILE))
;(define O_NOATIME   (pc O_NOATIME))
;(define O_NOCTTY    (pc O_NOCTTY))
;(define O_NOFOLLOW  (pc O_NOFOLLOW))
;(define O_NONBLOCK  (pc O_NONBLOCK))
;(define O_NDELAY    O_NONBLOCK)
;(define O_PATH      (pc O_PATH))
;(define O_SYNC      (pc O_SYNC))
;(define O_TMPFILE   (pc O_TMPFILE))
;(define O_TRUNC     (pc O_TRUNC))


;;
;; waitpid, wait
;; (see bits/waitflags.h)
;; XXX in the long run we might want to parse a prepared header
;; file to synchronize during compilation
;;
;; WAIT_ANY and WAIT_MYPGRP are still defined in VSI-C to be used
;; as special values for the argument /pid/


;; Bits in the third argument to `waitpid'.
(define	WNOHANG		(pc 1))	; Don't block waiting.
(define	WUNTRACED	(pc 2))	; Report status of stopped children.

;; Bits in the fourth argument to `waitid'. [XXX we don't even have that]
(define WSTOPPED	(pc 2))	; Report stopped child (same as WUNTRACED).
(define WEXITED		(pc 4))	; Report dead child.
(define WCONTINUED	(pc 8))	; Report continued child.
(define WNOWAIT		(pc #x01000000)) ; Don't reap, just poll status.

 ; Don't wait on children of other threads in this group
(define __WNOTHREAD     (pc #x20000000))

(define __WALL		(pc #x40000000)) ; Wait for any child.
(define __WCLONE	(pc #x80000000)) ; Wait for cloned process.

