(define sigset:template
  ;; # 22 "/usr/include/x86_64-linux-gnu/bits/sigset.h" 3 4
  (byte-string-clear!
   (make-byte-string (once (* (size-of-long)
                              (/ 1024 (* 8 (size-of-long))) ; NWORDS
))) ))
(define (asigset) (byte-string-copy sigset:template))

(define sys-div quotient) ;; XXX

(define (sigword-idx signal) ;; 53 <sigset.h>
  (sys-div (- signal 1) (* 8 (size-of-long))))
(define (sigword-off signal)
 (* sys-register-size (sigword-idx signal)))

(define sys-register-size (size-of-pointer)) ;; XXX put this somewhere else
(define (sys-modulo a b) ;; XXX see maintenance issues / math
 (byte-string->number ; size-of-pointer default-word-size
  (bit-modulo (number->byte-string a sys-register-size)
              (number->byte-string b sys-register-size))))

(define (sigmask signal)
  (bit-shift-left (number->byte-string 1 (size-of-long))
                  (sys-modulo (- signal 1)
                              (* 8 (size-of-long)))))
(define (sigemptyset! set) (byte-string-clear! set))
(define (sigfillset!  set) (bit-not! (sigemptyset! set)))

(define (sigismember? sigset signal)
 (bit-and? (sigmask signal)
           (byte-string-select sigset (sigword-off signal) (size-of-long))))

(define (sigaddset! sigset signal)
 (let ((off (sigword-off signal)))
  (byte-string-set! sigset off
   (bit-or (sigmask signal)
           (byte-string-select sigset off (size-of-long))))))

(define (sigdelset! sigset signal)
 (let ((off (sigword-off signal)))
  (byte-string-set! sigset off
   (bit-and (bit-not! (sigmask signal))
            (byte-string-select sigset off (size-of-long))))))

;; schemificationals
(define sigset-add!    sigaddset!)
(define sigset-delete! sigdelset!)
(define sigset-member? sigismember?)
(define sigset-fill!   sigfillset!)

(define (sigset-add sigset signal)
 (let ((s (byte-string-copy sigset)))
  (sigset-add! s signal)
  s))

(define (sigset-delete sigset signal)
 (let ((s (byte-string-copy sigset)))
   (sigset-delete! s signal)
   s))

(define (sigset-fill sigset signal)
 (let ((s (byte-string-copy sigset)))
   (sigset-fill! s signal)
   s))
