(when (and (defined? 'string)
           (eq? brass string)) ;; Simplistic Assertion
 (display "VSI-Core/string.compat.scm: no sense here; exitting"
          (current-error-port))
 (newline (current-error-port))
 (primitive-exit 1))

;; 1st level compatibility
(define string         brass)
(define string?        brass?)
(define string-length  brass-length)
(define make-string    make-brass)             ; incompatible compatibility
(define string-copy    brass-copy)
(define substring      subrass)
(define string-append  brass-append)
(define string-concatenate  brass-append)      ; incompatible compatibility
(define list->string   list->brass)
(define string->list   brass->list)
(define string->symbol brass->symbol)
(define symbol->string symbol->brass)
(define string-ref     brass-ref)
(define string-set!    brass-set!)
(define string-index   brass-index)
(define string-insert  brass-insert)
(define string-remove  brass-remove)
(define string-split   brass-split)
(define number->string number->brass)
(define string->number brass->number)
(define deprecated-string->c-string     brass->c-string)
(define c-string->deprecated-string/raw c-string->brass/raw)
(define c-string->deprecated-string     c-string->brass)


;; 2nd level compatibility
(define sys-cwis with-input-from-string)
(define sys-cwos with-output-to-string)
(define sys-cwes with-error-to-string)
(define sys-open-input-string open-input-string)

(define (with-input-from-brass brass thunk)
  (sys-cwis (brass->byte-string brass) thunk))
(define (with-output-to-brass thunk)
  (byte-string->brass (sys-cwos thunk)))
(define (with-error-to-brass thunk)
  (byte-string->brass (sys-cwes thunk)))

(define (open-input-brass br)
 (sys-open-input-string (brass->byte-string br))) ; XXX port encoding

(define with-input-from-string with-input-from-brass)
(define with-output-to-string  with-output-to-brass)
(define with-error-to-string   with-error-to-brass)
(define open-input-string      open-input-brass)

(define (subrass-fill! str start end fill)
 (when (< start (+ end 1))
  (brass-set! str start fill)
  (subrass-fill! str (+ start 1) end fill))) 

(define substring-fill! subrass-fill!)

(define object->byte-string/utf-8 object->string)
(define (object->brass obj) (byte-string->brass (object->byte-string/utf-8 obj)))
(define object->string object->brass)

(define (string-prefix? prefix brass) ; deprecated
 (and (<= (brass-length prefix) (brass-length brass))
      (equal? prefix (subrass brass 0 (brass-length prefix)))))
