(define queue-layout (struct box tail))
(define (make-queue) (let ((box (cons 'queue '())))
                       (struct-from-values queue-layout box box)))

(define (queue? obj) (is-a? obj queue-layout))

(define (queue!   q obj) (let ((p (list obj)))
                           (set-cdr! (@slot-ref q 'tail) p)
                           (@slot-set! q 'tail p)))

(define (unqueue! q)     (let* ((box (@slot-ref q 'box))
                                (fel (cdr box)))
                           (cond
                            ((null? fel) '())
                            (else
                             (when (null? (cdr fel)) (@slot-set! q 'tail box))
                             (car fel) )) ))

(define (queue->list/nocopy q) (cdr (@slot-ref q 'box)))
(define (queue->list q) (list-copy (queue->list/nocopy q)))
