;; call counters count upwards only (dynwind is such a call counter)
;(define root "/usr/share")
(define root "/usr")
(define total-size        0)
(define number-of-entries 0)

(define (directory->list path)
 (let ((dir (opendir path)))
  (let loop ((entry (readdir dir))
             (entries '()))
   (if (eof-object? entry)
     (begin (closedir dir) (filter (lambda (entry)
                                     (not (or (equal? entry ".")
                                              (equal? entry ".."))))
                                   entries))
     (loop (readdir dir) (cons entry entries)) )) ))

(define (stat:size sv) (vector-ref sv 7))
(define (stat:type sv) (vector-ref sv 13))
(define (scan-fs path)
 (let* ((entries (directory->list path))
        (info (map (lambda (entry)
                     ;; We use lstat: guess which package went circular here!?
                     (lstat (string-append path "/" entry)))
                   entries)))
   (set! number-of-entries (+ (length entries) number-of-entries))
   (set! total-size (+ total-size (apply + (map stat:size info))))
   (for-each (lambda (entry stat)
               (when (eq? (stat:type stat) 'directory)
                 (scan-fs (string-append path "/" entry))))
             entries
             info) ))

(sys-load "VSI-core/repl.scm")

(repl-transcript
(global-object-count->alist)
(global-call-count->alist)

root
(define repetitions 1)
(let loop ((n 0))
 (when (< n repetitions)
   (display ".")
   (scan-fs root)
   (loop (+ n 1))))
total-size
number-of-entries
(exact->inexact (/ total-size number-of-entries))

(global-object-count->alist)
(global-call-count->alist)
;(pause)
)
