;; ;;
;; ;; Implicit Scheme (minimal) Initialization
;; ;;

;; (primitive-load "VSI-core/boot-9.defmacros.scm")

;; (define call-with-values @call-with-values)

;; (define-macro (receive values variables . expressions)
;;   `(call-with-values (lambda () ,values)
;;      (lambda ,variables ,@expressions)))


;; ;; Dependency Chain: deprecation -> defmacros
;; (primitive-load-path "VSI-core/boot-9.features.scm")
;; (primitive-load-path "VSI-core/boot-9.defmacros.scm")

;; ;; Basics
;; (primitive-load-path "VSI-core/vsi.scm")
;; (primitive-load-path "VSI-core/data-flow.scm")

;; (define (global-object-count->alist)
;;   (receive (%global-object-counts)
;;     ( . counts)
;;    (map cons
;;      '(cell-segments double-cell-segments
;;        cells double-cells fuel pairs vectors strings variables symbols
;;        closures compiled-closures smob-cell-counts)
;;      counts)))

;;
;; Counting Lambda Revision IV: preliminaries
;;  efficency of named let, environments and inherent rings
;;

(define (alist-copy/named-let alist)
 (let ((answer-box (cons 'alist-copy '()) ))
  (let loop ((last answer-box) (rest alist))
    ;(display "$")
   (cond
    ((null? rest)       (cdr answer-box))

    ((not (pair? rest))
       ;; This reflects the behavior of the former C version but we
       ;; could as well just return what we have copied up to here.
       (error "alist-copy: argument is not a proper association list"))

    (else
       (let ((key-value (car rest)))
        (cond ((not (pair? key-value))
               (error
                "alist-copy: argument contains an invalid key value pair"))
              (else
               (set-cdr! last (acons (car key-value) (cdr key-value)
                                     '()))
               (loop (cdr last) (cdr rest)) ))) ))) ))

;;
;; CLR4 Prototype: cut the ring before returning.
;;  (This currently doesn't stop leakage. The reason is unknown.)
(define (alist-copy/named-let-finibile alist)
 (let ((answer-box (cons 'alist-copy '()) ))
  (let loop ((last answer-box) (rest alist))
   (cond
    ((null? rest)   (set! loop #f) (cdr answer-box))

    ((not (pair? rest))
       (set! loop #f)
       ;; This reflects the behavior of the former C version but we
       ;; could as well just return what we have copied up to here.
       (error "alist-copy: argument is not a proper association list"))

    (else
       (let ((key-value (car rest)))
        (cond ((not (pair? key-value))
                 (set! loop #f)
                 (error
                  "alist-copy: argument contains an invalid key value pair"))
              (else
               (set-cdr! last (acons (car key-value) (cdr key-value)
                                     '()))
               (loop (cdr last) (cdr rest)) ))) ))) ))

(define (alist-copy/with-helper alist)
 (let ((answer-box (cons 'alist-copy '()) ))
   (alist-copy-helper answer-box answer-box alist) ))
(define (alist-copy-helper answer-box last rest)
  (cond
   ((null? rest)       (cdr answer-box))

   ((not (pair? rest))
    ;; This reflects the behavior of the former C version but we
    ;; could as well just return what we have copied up to here.
    (error "alist-copy: argument is not a proper association list"))

   (else
    (let ((key-value (car rest)))
      (cond ((not (pair? key-value))
               (error
                "alist-copy: argument contains an invalid key value pair"))
            (else
               (set-cdr! last (acons (car key-value) (cdr key-value)
                                     '()))
               (alist-copy-helper answer-box (cdr last) (cdr rest)) ))) )))

(define alist-copy alist-copy/named-let)

(display (global-object-count->alist)) (newline)
(display (%global-call-counters)) (newline)

(let loop ((i 0))
 (if (>= i 50000)
  #t
  (begin (if (= (modulo i 100) 0) (display "."))
         (alist-copy (global-object-count->alist))
         (loop (+ i 1))) ))
(newline)

(display (global-object-count->alist)) (newline)
(display (%global-call-counters)) (newline)


;;
;; Inner Defines
;;
(define (inner-define-0)
  (define a (list 'a 'b 'c 'd))
  (define b (vector 1 2 3))
  (cut! a (cut! b (+ (length a) (vector-length b))))) ; this is really slow
;; and uselsess but it's about testing that combination here

(define (inner-define-1)
  (define (inner)
    (+ 2 2))
  (cut! inner (inner)))

(define (inner-define-2)
  (define (recursive yes)
   (if yes
    (recursive #f)
    (+ 2 2)))
  (cut! recursive (recursive #t)))

(define (inner-define-1a)
 (letrec ((inner (lambda () (+ 2 2)) ))
  (cut! inner (inner)) ))
  ;inner))

(sys-load "VSI-core/repl.scm")

(define 1k 1000)
(define 1M (* 1k 1k))

(newline) (display "CLR4 inner") (newline)
(repl-transcript
 (global-object-count->alist)
 (global-call-count->alist)

 (repeat (* 1 1M) inner-define-0)

 (global-object-count->alist)
 (global-call-count->alist)

 (repeat (* 1 1M) inner-define-1a)

 (global-object-count->alist)
 (global-call-count->alist)

 (repeat (* 1 1M) inner-define-1)

 (global-object-count->alist)
 (global-call-count->alist)

 (repeat (* 1 1M) inner-define-2)

 (global-object-count->alist)
 (global-call-count->alist)
)
