(sys-load "VSI-core/repl.scm") (repl-clear)
;;
;; Please note: the REPL (including the arithmetic of its printer)
;; is a full fledged application from the point of view of memory
;; management and the new load variants keep a reference onto the
;; complete program including any literal constants during all the
;; evaluation of a file.
;;


;;
;; Complex
(repl-transcript
(global-object-count->alist)
(define c (make-rectangular 1 1))
(debug-purple c 10)
(imag-part c)
(real-part c)
(magnitude c)
(angle     c)
(debug-purple c 10)
(set! c #f)
(global-object-count->alist)
)

(newline)(newline)
;;
;; Fraction
(repl-transcript
(global-object-count->alist)
(define a 2/3)
(define b 1000000000000000000/3)
(define c (/ 3 1000000000000000000))
a b c
(debug-purple a 10)
(debug-purple b 10)
(debug-purple c 10)
(numerator a)
(denominator b)
a b c
(global-object-count->alist)
(set! a #f)
(set! b #f)
(set! c #f)
(global-object-count->alist)
)


(newline)(newline)
;;
;; First Order Predicates

(define predicates (list number?))
(define complex-predicates
  (list exact? inexact? complex? real? rational?
        integer? inf? nan? zero?))
(define number-predicates
  (append complex-predicates
          (list negative? positive?)))
(define integer-predicates
  (list odd? even?))

(define integer-set (list 1 1.0 (expt 2 250)))
(define  number-set (append integer-set
                            (list (/ 2 3) (/ 5 (expt 2 250))
                                  0.3)))
(define complex-set (append integer-set
                             number-set
                            (list 7.1+4.3i)))
(define (x-each ops vals)
  (for-each (lambda (op)
              (for-each (lambda (val) (op val))
                        vals))
            ops))

(repl-transcript
(global-object-count->alist)
(map (lambda (obj) (and (not (immediate? obj))
                             (debug-purple obj 10))) complex-set)
(repeat (* 10 1k) (lambda ()
 (x-each integer-predicates integer-set)
 (x-each complex-predicates complex-set)
 (x-each  number-predicates  number-set)
 (x-each         predicates  number-set)))
(map (lambda (obj) (and (not (immediate? obj))
                             (debug-purple obj 10))) complex-set)
(global-object-count->alist)
)
