#!/opt/VSI/interpreter --
!#

(sys-load "VSI-core/repl.scm")

;; CLR3 serializable error objects (see also Examples/subservice.scm)
(define (error-object key . args)
 (cons 'error-object-prototype (cons key args)))

(define continue (macro ( . expressions)
  `(catch #t (lambda () ,@expressions)
          ,error-object)))

;; Auxiliaries
(define (net-list producer)
 (let ((result (producer)))
  (cond (result       (cons result (net-list producer)))
        ((not result) '()) )))

;; Test Sessions
(repl-clear)

; DB Read Out
(repl-transcript
(global-object-delta)

(define hosts     (net-list gethost ))
(define networks  (net-list getnet  ))
(define services  (net-list getserv ))
(define protocols (net-list getproto))
(global-object-delta)
)

(when #t ; Errors and Lookups
(newline) (newline)
(repl-transcript
(define rt repl-transcript)
(define rt continue)

(rt (gethost "localhost"))
(rt (gethost ""))
(rt (gethost "no-host-1234123412111221"))
(rt (gethost "127.0.0.1"))
))

; Release after throws
(repl-transcript
(global-object-delta)(
length hosts
      )(
length networks
      )(
length services
      )(
length protocols
      )(
    begin(

    set!    hosts #f  )(  set!  networks #f
                      )(
    set! services #f  )(  set! protocols #f
                      )(
             global-object-delta
))

)

(REPL)
