(define 1k 1000)
(define softness 0) ; ??? 100 and 50 both lead to 12,5% CPU usage

(define (port-table-size)
 (length (sys-ports)))

;; Hey, that's one nice MOS notation of an implementation of an inter-
;; face, isn't it? Mix cyan and blue and then it already looks like
;; unicode ;-) 
(define (cyan-port)
 (let* ((braid (apply circular-list (string->list "cyan-port")))
        ;(ok    (begin (display ".") #t))
        (current braid))
 (make-soft-port
 (vector
   (lambda (char)
     (color (current-output-port) 'foreground 'cyan)
     (display "cyan-port-output"))
   (lambda (string)
     (color (current-output-port) 'foreground 'cyan)
     (display string))
   force-output
   (lambda () (set! current (cdr braid)) (car current))
   (lambda ()
     ;(display "Thanks for using the cyan port! We're closing now.")
     ;(newline)
     ; you don't want to see this 1k times
     (set-cdr! current '())
     (when (not (null? braid))
      (set-cdr! braid '() )) ; cut our ring
     #t)
   (lambda () +inf.0) ; I don't think the other routines will understand this.
)
 "rw")
 ))

(define (soft-ports)
  (close (cyan-port)))

(define (fports)
  (usleep softness)
  (close (open-file "Examples/utf-8.txt" "r")))

(define (strports)
  (usleep softness)
  (close (open-input-string (string-copy "test"))))

(define (void-ports)
  (usleep softness)
  (close (%make-void-port "r")))

;; TODO void ports
;; TODO soft ports

(define (ports)
 (let (
  (f (open-file "Examples/utf-8.txt" "r"))
  (s (open-input-string (string-copy "test")))
  (v (%make-void-port "r"))
  )
   (values f s v) ))

(define (port-enumerator length) ; XXX there is a resource limit: currently 1024
 (usleep softness)
 (let loop ((n length)
            (answer '()))
 (if (= 0 n)
   answer
   (loop (- n 1) (append! answer (ports))) )))
     
 

(sys-load "VSI-core/repl.scm")
(repl-transcript
 (port-table-size)
 ;; (global-object-count->alist)
 ;; (global-call-count->alist)

 ;; (repeat (* 1k 1k) fports)

 ;; (global-object-count->alist)
 ;; (global-call-count->alist)

 ;; (repeat (* 1k 1k) strports)

 ;; (global-object-count->alist)
 ;; (global-call-count->alist)

 ;; (repeat (* 1k 1k) void-ports)

 (global-object-count->alist)
 (global-call-count->alist)
 
 (repeat (* 1k 1k) soft-ports)

 (global-object-count->alist)
 (global-call-count->alist)

 (and #f (begin ;; Extended paragraph: port table size check
  (port-table-size)
  (define l '())
  (repeat 1k (lambda () (for-each close (port-enumerator (* 1 1k))) ))
  (port-table-size) ))

 (define p (cyan-port))
 (display "Hello Cyan!" p) (newline)
)
(REPL)
